(* mathematica script for plotting projected bulk bandstructure *)

Needs["Graphics`FilledPlot`"];
(* EFermi=9.9416; *)
EFermi=Input["Fermi Energie:"];

NB=16; NN=11;
a={12,7,12,7,13.9,8,8,8}/(NN-1);

ND=Length[a];
b=Join[a,{0}];
For[i=2;b[[1]]=0,i<Length[a]+2,i++,b[[i]]=Sum[a[[j]],{j,1,i-1}](NN-1)];

KTrafo[{k_,e_}]:={KScale[k],e-EFermi};
KScale[n_]:=a[[1]](n-1-0NN)+b[[1]] /; (0NN<n<1NN+1);
KScale[n_]:=a[[2]](n-1-1NN)+b[[2]] /; (1NN<n<2NN+1);
KScale[n_]:=a[[3]](n-1-2NN)+b[[3]] /; (2NN<n<3NN+1);
KScale[n_]:=a[[4]](n-1-3NN)+b[[4]] /; (3NN<n<4NN+1);
KScale[n_]:=a[[5]](n-1-4NN)+b[[5]] /; (4NN<n<5NN+1);
KScale[n_]:=a[[6]](n-1-5NN)+b[[6]] /; (5NN<n<6NN+1);
KScale[n_]:=a[[7]](n-1-6NN)+b[[7]] /; (6NN<n<7NN+1);
KScale[n_]:=a[[8]](n-1-7NN)+b[[8]] /; (7NN<n<8NN+1);

BB=ReadList["../bulk/BBAND",{Number,Number}];
BBAND=Map[KTrafo,BB];
BT=Table[Take[BBAND,{(i-1)ND NN+1,i ND NN}],{i,1,2 NB}];

BPlot:= ListFilledPlot[Apply[Sequence,BT],Curves->None,Fills->fillopt,opt];

fillopt=Sequence[Table[{{2i-1,2i},GrayLevel[.95]},{i,1,NB}]]; 

emin=-8 ; emax=8 ;

yticks=Table[{i,"",{.007,0},Thickness[0.003]},{i,Ceiling[emin],Floor[emax]}];
yticks=Join[yticks,Table[{2i,2i,{0.014,0},Thickness[0.003]},{i,Ceiling[emin/2],Floor[emax/2]}]];
xticks={{0.0001,FontForm[G,{"Symbol",12.}]},{b[[2]],J},{b[[3]],K},
        {b[[4]],J'},{b[[5]],FontForm[G,{"Symbol",12.}]},{(b[[5]]+b[[6]])/2,60,{0,0}},{b[[6]],K},
        {(b[[7]]+b[[8]])/2,30,{0,0}},{b[[9]],FontForm[G,{"Symbol",12.}]}};
grid={{b[[2]],Thickness[.003]},{b[[3]],Thickness[.003]},{b[[4]],Thickness[.003]},
       {b[[5]],Thickness[.003]},{b[[6]],Thickness[.003]}};

opt=Sequence[
      DisplayFunction->Identity,
      DefaultFont->{"Helvetica",12},
      Prolog->PointSize[0.015],
      PlotStyle->Thickness[0.003],
      AxesStyle->Thickness[0.003],
      FrameStyle->Thickness[0.003],
      Frame->True,
      FrameTicks->{xticks,yticks},
      GridLines->{grid,None},
      PlotRange->{{0,b[[9]]},{emin,emax}},
      FrameLabel->{"","E [eV]"},
      (* PlotLabel->"Projizierte bulk-Bandstruktur in (111) Richtung", *)
      AspectRatio->60/b[[9]]];

BPlot
