GS[g_]:=0  /; (0 <= g < 1) ;
GS[g_]:=.5 /; (1 <= g < 2) ;
GS[g_]:=.8 /; (2 <= g    ) ;
PS[i_]:=0.07 /; (1 <= i <=32 );
PS[i_]:=0.04 /; (33 <= i     );
FScale[{x_,z_,g_,i_}]:={PointSize[PS[i]], GrayLevel[GS[Abs[g]]], Point[{x,z}]};

snum=OpenRead["PLANE.M"];
label=Read[snum,String];
nx=Read[snum,Number]; nz=Read[snum,Number];
rhomin=Read[snum,Number];
rhomax=Read[snum,Number];
u=Read[snum,{Number,Number,Number}];
v=Read[snum,{Number,Number,Number}];
o=Read[snum,{Number,Number,Number}];
plane=Table[Read[snum,Number],{i,1,nz},{j,1,nx}];
plane=plane*rhomax;
acount=Read[snum,Number];
atom=Table[Read[snum,{Number,Number,Number,Number}],{i,1,acount}];
atomxy=Table[{atom[[i,1]],atom[[i,2]]},{i,1,acount}];
len=Read[snum,{Number,Number}];
lenu=len[[1]]; lenv=len[[2]];
Close[snum];

as=Table[FScale[ atom[[i]] ],{i,1,Length[atomxy]}];
con={{2,4},{4,6},{6,7},{7,9} };
connect=Table[{Line[{atomxy[[ con[[i,1]] ]],atomxy[[ con[[i,2]] ]]}]},
     {i,1,Length[con]}];
text={Text["a)",{3,nz-2}]};
as=Join[as,connect,text];

cont=Table[i/20,{i,1,40}];
opt=Sequence[DefaultFont->{"Helvetica",12.},
             ContourShading->False, ContourSmoothing->Automatic,
             FrameTicks->None, FrameLabel->{"x","z"},
             AspectRatio->(nz-5)/nz*lenv/lenu,
           (*  PlotLabel->label , *) Contours->cont,
             PlotRange->{{1,nx},{6,nz},{0,rhomax}}
            ];

cp=ListContourPlot[plane,opt];
fig=Show[cp,Prolog->as];

Display["!psfix > chg.ps",fig];

