*
*   This dos.f is neither compatibel to dos.f of vamp.2.3 nor
*   compatibel to dos.f of vasp.3.X
*   for vamp.2.3 the actual number of bands must be the same as the
*   dimension
*   for vasp.3.X spin is included in dos.f 
*                                                           gK
*



*********************DENINI**********************************************
*
* initialise the fermi-weights
* if the total number of bands is larger than the number of occupied
* bands:
* initialize the fermi occupation function
* FERWE  1  for the lowest fully occupied nelect/2 bands
*       .5  for the (nelect/2+1)th band if nelect odd
*        0  for the empty bands
*
* non-metallic systems set all components of FERWE equal 1
*
*************************************************************************

      SUBROUTINE  DENINI(FERWE,NBANDS,NBANDD,NKPTS,NELECT)
      DIMENSION FERWE(NBANDD,NKPTS)

       IF (ABS(NBANDS-NELECT/2).GE.0.0001) THEN
          NBE=NELECT/2
          DO 41 NB=1,NBE
          DO 41 KP=1,NKPTS
 41         FERWE(NB,KP)=1.
          RNBE=REAL(NELECT)/2.
          IF (ABS(RNBE-NBE).GT.0.1) THEN
            DO 42 KP=1,NKPTS
 42           FERWE(NBE+1,KP)=0.5
          ELSE
            DO 43 KP=1,NKPTS
 43           FERWE(NBE+1,KP)=0.
          ENDIF
          DO 44 NB=NBE+2,NBANDS
          DO 44 KP=1,NKPTS
 44         FERWE(NB,KP)=0.
        ELSE
          DO 45 NB=1,NBANDS
          DO 45 KP=1,NKPTS
 45         FERWE(NB,KP)=1.
        ENDIF
      RETURN
      END


************************SUBROUTINE DENSTA*******************************
* if ISMEAR=0
* subroutine DENSTA calculates a continuous density of states in the
* interval (EMIN,EMAX) by applying a gaussian broadening to the discrete
* eigenvalue spectrum contained in CELEN(NBANDD,NKPTS). The width of the
* gaussians is SIGMA. The fermi energy EFERMI is calculated from the
* integrated dos
* correction to the variational energy is calculated (-SIGMA S)
* according to A.de Vita, private communication
* if ISMEAR>0 the generalized form of Methfessel and Paxton of order
*        N=ISMEAR will be used instead of Gaussians to get the dos ...
* if ISMEAR=-1 fermi-smearing DENSTA calls DENFER
* if ISMEAR=-4,-5 the tetrahedron method will be used
************************************************************************

      SUBROUTINE DENSTA(CELEN,WTKPT,NBANDS,NBANDD,NKPTS,DOS,DOSI,NEDOS,
     &       EMIN,EMAX,ISMEAR,VSIG,NELECT,EFERMI,FERWE,ECORR,IDTET,NTET,
     &              VOLWGT,LTET,IU6,PAR,DOSPAR,NKDIM,LDIMP,NIONS,JOBPAR)
      IMPLICIT COMPLEX (C)
      LOGICAL LOWB,HIGHB,LTET,LAUTO
      DIMENSION CELEN(NBANDD,NKPTS),FERWE(NBANDD,NKPTS),WTKPT(NKPTS)
      DIMENSION DOS(NEDOS),DOSI(NEDOS),IDTET(0:4,NTET)
      DIMENSION PAR(NBANDD,NKDIM,LDIMP,NIONS),DOSPAR(NEDOS,LDIMP,NIONS)
      COMMON /CONPI/    CITPI,TPI,PI
      SAVE LAUTO,ICALLS
      DATA LAUTO /.FALSE./, ICALLS /0/

* Automatic adjustement of energy interval:
      IF (ICALLS.EQ.0) THEN
         LAUTO=(EMAX.LE.EMIN)
         ICALLS=1
      ENDIF

      IF (LAUTO) THEN
        EMIN=1.E30
        EMAX=-EMIN
        DO 40 K=1,NKPTS
        DO 40 N=1,NBANDS
          EPS=REAL(CELEN(N,K))
          EMAX=MAX(EMAX,EPS)
          EMIN=MIN(EMIN,EPS)
  40    CONTINUE
        EADD=(EMAX-EMIN)*0.05
        IF (ISMEAR.GE.0) EADD=MAX(EADD,9.*ABS(VSIG))
        IF (ISMEAR.EQ.-1) EADD=MAX(EADD,32.*ABS(VSIG))
        EMIN=EMIN-EADD
        EMAX=EMAX+EADD
      ENDIF

      IF (ISMEAR.EQ.-1) THEN
         CALL DENFER(CELEN,WTKPT,NBANDS,NBANDD,NKPTS,DOS,DOSI,NEDOS,
     &                     EMIN,EMAX,VSIG,NELECT,EFERMI,FERWE,ECORR,
     &                          PAR,DOSPAR,NKDIM,LDIMP,NIONS,JOBPAR)
         IF (LTET) THEN
            CALL DENTET(CELEN,WTKPT,NBANDS,NBANDD,NKPTS,DOS,DOSI,NEDOS,
     &                  EMIN,EMAX,IDTET,NTET,VOLWGT,NELECT,EFERMI,FERWE,
     &                  ECORR,0,IU6,PAR,DOSPAR,NKDIM,LDIMP,NIONS,JOBPAR)
         ENDIF
         RETURN
      ENDIF

      IF (ISMEAR.EQ.-4) THEN
         CALL DENTET(CELEN,WTKPT,NBANDS,NBANDD,NKPTS,DOS,DOSI,NEDOS,
     &                EMIN,EMAX,IDTET,NTET,VOLWGT,NELECT,EFERMI,FERWE,
     &                 ECORR,-2,IU6,PAR,DOSPAR,NKDIM,LDIMP,NIONS,JOBPAR)
         RETURN
      ENDIF

      IF (ISMEAR.EQ.-5) THEN
         CALL DENTET(CELEN,WTKPT,NBANDS,NBANDD,NKPTS,DOS,DOSI,NEDOS,
     &                EMIN,EMAX,IDTET,NTET,VOLWGT,NELECT,EFERMI,FERWE,
     &                  ECORR,2,IU6,PAR,DOSPAR,NKDIM,LDIMP,NIONS,JOBPAR)
         RETURN
      ENDIF

      SIGMA=ABS(VSIG)
      IF (SIGMA.EQ.0) RETURN

      DELTAE=(EMAX-EMIN)/(NEDOS-1)

C=======================================================================
C initialize arrays for dos and integr. dos
C=======================================================================

      IF (JOBPAR.NE.0) THEN
         DO 1 NI=1,NIONS
          DO 1 LP=1,LDIMP
           DO 1 I=1,NEDOS
    1    DOSPAR(I,LP,NI)=0.
      ENDIF
      DO 2 I=1,NEDOS
        DOS(I)=0.
    2 DOSI(I)=0.

C=======================================================================
C accumulate dos and integrated dos
C=======================================================================

      DO 4 K=1,NKPTS
      DO 4 N=1,NBANDS
        EPS=REAL(CELEN(N,K))
        NELOW=(EPS-8.*SIGMA-EMIN)/DELTAE+1
        NEHIG=(EPS+8.*SIGMA-EMIN)/DELTAE+1
        IF (NELOW.LT.1)     NELOW=1
        IF (NELOW.GT.NEDOS) NELOW=NEDOS
        IF (NEHIG.LT.1)     NEHIG=1
        IF (NEHIG.GT.NEDOS) NEHIG=NEDOS

        DO 3 I=NELOW,NEHIG
          E=EMIN+DELTAE*(I-1)-EPS
          CALL DELSTP(ISMEAR,(E/SIGMA),DFUN,SFUN)
          EPSDOS=DFUN/SIGMA*WTKPT(K)
          DOS(I)=DOS(I)+2.*EPSDOS
          DOSI(I)=DOSI(I)+2.*SFUN*WTKPT(K)
          IF (JOBPAR.NE.0) THEN
             DO 31 NI=1,NIONS
              DO 31 LP=1,LDIMP
   31        DOSPAR(I,LP,NI)=DOSPAR(I,LP,NI)+2.*EPSDOS*PAR(N,K,LP,NI)
          ENDIF
    3   CONTINUE
        DO 5 I=1,NELOW-1
          E=EMIN+DELTAE*(I-1)-EPS
          CALL DELSTP(ISMEAR,(E/SIGMA),DFUN,SFUN)
    5   DOSI(I)=DOSI(I)+2.*SFUN*WTKPT(K)
        DO 51 I=NEHIG+1,NEDOS
          E=EMIN+DELTAE*(I-1)-EPS
          CALL DELSTP(ISMEAR,(E/SIGMA),DFUN,SFUN)
   51   DOSI(I)=DOSI(I)+2.*SFUN*WTKPT(K)
    4 CONTINUE

C=======================================================================
C calculate approximated fermi energy
C=======================================================================

      DO 6 I=1,NEDOS
        IF (ABS(DOSI(I)-NELECT).LT.0.01.OR.DOSI(I).GT.NELECT) THEN
          GO TO 7
        ENDIF
    6 CONTINUE

    7 CONTINUE
      EFERMI= EMIN+(I-1)*DELTAE

C----- recalculate DOS/DOSI using tetrahedron method (if desired ...):
      IF (LTET) THEN
         CALL DENTET(CELEN,WTKPT,NBANDS,NBANDD,NKPTS,DOS,DOSI,NEDOS,
     &                EMIN,EMAX,IDTET,NTET,VOLWGT,NELECT,EFERMI,FERWE,
     &                  ECORR,0,IU6,PAR,DOSPAR,NKDIM,LDIMP,NIONS,JOBPAR)
      ENDIF

      IF (VSIG.LT.1E-5) RETURN

C=======================================================================
C search now for exact Fermi-level
C=======================================================================
      EF1= EMIN+(I-2)*DELTAE
      LOWB =.FALSE.
      EF2= EMIN+(I-1)*DELTAE
      HIGHB=.FALSE.

  100 EFERMI=(EF1+EF2)/2

C=======================================================================
C calculate fermi-weighting function, and their sum
C=======================================================================

      ELECT=0
      DO 8 K=1,NKPTS
      DO 8 N=1,NBANDS
        EPS=REAL(CELEN(N,K))
        X1=(EFERMI-EPS)/SIGMA
        CALL DELSTP(ISMEAR,X1,DFUN,SFUN)
        FERWE(N,K)=SFUN
        ELECT=ELECT+FERWE(N,K)*WTKPT(K)
    8 CONTINUE
      ELECT=ELECT*2

C=======================================================================
C compare now with Number of Electrons
C=======================================================================
      IF ( ABS(ELECT-NELECT).LT.1E-10) GOTO 110
      IF ( (ABS(EF1-EF2)/(ABS(EFERMI)+1.E-10)).LT.1E-14) GOTO 120
      IF ( ELECT.GT.NELECT) THEN
        IF (.NOT.LOWB)  EF1=EF1-DELTAE
        HIGHB=.TRUE.
        EF2  =EFERMI
        GOTO 100
      ELSE
        IF (.NOT.HIGHB) EF2=EF2+DELTAE
        LOWB =.TRUE.
        EF1  =EFERMI
        GOTO 100
      ENDIF
  120 WRITE(*,*)' WARNING: DENSTA: can`t reach specified precision'
      WRITE(*,*)' Number of Electrons is NELECT =',ELECT

  110 CONTINUE
C=======================================================================
C calculate -SIGMA * S
C=======================================================================
      ECORR=0
      DO 200 K=1,NKPTS
      DO 200 N=1,NBANDS
        X1=(EFERMI-CELEN(N,K))/SIGMA
        CALL DELSTP(ISMEAR,X1,DFUN,SFUN)
        ECORR=ECORR+0.5*DFUN*WTKPT(K)
        IF (ISMEAR.GT.0) THEN
          CALL DELSTP((ISMEAR-1),X1,DFUN,SFUN)
          ECORR=ECORR-0.5*DFUN*WTKPT(K)
        ENDIF
  200 CONTINUE

      ECORR=-ECORR*SIGMA*2.

      RETURN
      END

************************SUBROUTINE DENFER******************************
*
* subroutine DENFER calculates a continuous density of states in the
* interval (EMIN,EMAX) by applying a fermi broadening to the discrete
* eigenvalue spectrum contained in CELEN(NBANDD,NKPTS). The width of the
* broadening is SIGMA (=1/BETA). EFERMI is calculated so that
* sum over occupation-numbers is equal to number of electrons
* in addition the correction to the variational energy is calculated
* as proposed by M. Weinert J.W. Davenport, Phys Rev B 45, 13709 (1992)
***********************************************************************

      SUBROUTINE DENFER(CELEN,WTKPT,NBANDS,NBANDD,NKPTS,DOS,DOSI,
     &                    NEDOS,EMIN,EMAX,VSIG,NELECT,EFERMI,FERWE,
     &                       ECORR,PAR,DOSPAR,NKDIM,LDIMP,NIONS,JOBPAR)
      IMPLICIT COMPLEX (C)
      LOGICAL LOWB,HIGHB
      DIMENSION CELEN(NBANDD,NKPTS),FERWE(NBANDD,NKPTS),WTKPT(NKPTS)
      DIMENSION DOS(NEDOS),DOSPAR(NEDOS,LDIMP,NIONS)
      DIMENSION DOSI(NEDOS),PAR(NBANDD,NKDIM,LDIMP,NIONS)

C---- fermi function and its derivative

      F(E,SIG)=  1/(1 + EXP(E /SIG))
      G(E,SIG)=  1/EXP(E/SIG)/(1 + EXP(-E/SIG))**2/SIG

      SIGMA=ABS(VSIG)
      IF (SIGMA.EQ.0) RETURN

      DELTAE=(EMAX-EMIN)/(NEDOS-1)
C=======================================================================
C initialize arrays for dos and integr. dos
C=======================================================================

      IF (JOBPAR.NE.0) THEN
         DO 1 NI=1,NIONS
          DO 1 LP=1,LDIMP
           DO 1 I=1,NEDOS
    1    DOSPAR(I,LP,NI)=0.
      ENDIF
      DO 2 I=1,NEDOS
        DOS(I)=0.
    2 DOSI(I)=0.

C=======================================================================
C accumulate dos and integrated dos
C=======================================================================

      DO 4 K=1,NKPTS
      DO 4 N=1,NBANDS
        EPS=REAL(CELEN(N,K))
        NELOW=(EPS-30.*SIGMA-EMIN)/DELTAE+1
        NEHIG=(EPS+30.*SIGMA-EMIN)/DELTAE+1
        IF (NELOW.LT.1)     NELOW=1
        IF (NELOW.GT.NEDOS) NELOW=NEDOS
        IF (NEHIG.LT.1)     NEHIG=1
        IF (NEHIG.GT.NEDOS) NEHIG=NEDOS

        DO 3 I=NELOW,NEHIG
          E=EMIN+DELTAE*(I-1)-EPS
          EPSDOS=G(E,SIGMA)*WTKPT(K)
          DOS(I)=DOS(I)+2.*EPSDOS
          DOSI(I)=DOSI(I)+2.*F(-E,SIGMA)*WTKPT(K)
          IF (JOBPAR.NE.0) THEN
             DO 31 NI=1,NIONS
              DO 31 LP=1,LDIMP
   31        DOSPAR(I,LP,NI)=DOSPAR(I,LP,NI)+2.*EPSDOS*PAR(N,K,LP,NI)
          ENDIF
    3   CONTINUE
        DO 5 I=1,NELOW-1
          E=EMIN+DELTAE*(I-1)-EPS
    5   DOSI(I)=DOSI(I)+2.*F(-E,SIGMA)*WTKPT(K)
        DO 51 I=NEHIG+1,NEDOS
          E=EMIN+DELTAE*(I-1)-EPS
   51   DOSI(I)=DOSI(I)+2.*F(-E,SIGMA)*WTKPT(K)
    4 CONTINUE

C=======================================================================
C calculate approximated fermi energy
C=======================================================================

      DO 6 I=1,NEDOS
        IF (ABS(DOSI(I)-NELECT).LT.0.01.OR.DOSI(I).GT.NELECT) THEN
          GO TO 7
        ENDIF
    6 CONTINUE

    7 CONTINUE
      EFERMI= EMIN+(I-1)*DELTAE
      IF (VSIG.LT.1E-5) RETURN

C=======================================================================
C search now for exact Fermi-level
C=======================================================================
      EF1= EMIN+(I-2)*DELTAE
      LOWB =.FALSE.
      EF2= EMIN+(I-1)*DELTAE
      HIGHB=.FALSE.

  100 EFERMI=(EF1+EF2)/2

C=======================================================================
C calculate fermi-weighting function, and their sum
C=======================================================================

      ELECT=0
      DO 8 K=1,NKPTS
      DO 8 N=1,NBANDS
        EPS=REAL(CELEN(N,K))
        FERWE(N,K)=F(EPS-EFERMI,SIGMA)
        ELECT=ELECT+FERWE(N,K)*WTKPT(K)
    8 CONTINUE
      ELECT=ELECT*2

C=======================================================================
C compare now with Number of Electrons
C=======================================================================
      IF ( ABS(ELECT-NELECT).LT.1E-10) GOTO 110
      IF ( (ABS(EF1-EF2)/(ABS(EFERMI)+1.E-10)).LT.1E-14) GOTO 120
      IF ( ELECT.GT.NELECT) THEN
        IF (.NOT.LOWB)  EF1=EF1-DELTAE
        HIGHB=.TRUE.
        EF2  =EFERMI
        GOTO 100
      ELSE
        IF (.NOT.HIGHB) EF2=EF2+DELTAE
        LOWB =.TRUE.
        EF1  =EFERMI
        GOTO 100
      ENDIF
  120 WRITE(*,*)' WARNING: DENFER: can`t reach specified precision'
      WRITE(*,*)' Number of Electrons is NELECT =',ELECT

  110 CONTINUE

C=======================================================================
C calculate the correction term to the total Energy
C factor 2 because SUM FERWE=NELECT/2
C=======================================================================
      ECORR= 0

      DO 200 K=1,NKPTS
       DO 200 N=1,NBANDS
        IF (FERWE(N,K) .NE.0 .AND. FERWE(N,K) .NE.1)
     &  ECORR=ECORR+FERWE(N,K)    *LOG(FERWE(N,K))*WTKPT(K)+
     &            (1-FERWE(N,K))*LOG(1-FERWE(N,K))*WTKPT(K)
  200 CONTINUE
      ECORR=ECORR*SIGMA*2
      RETURN
      END

************************SUBROUTINE DENTET******************************
*
* subroutine DENTET calculates a continuous density of states in the
* interval (EMIN,EMAX) applying the tetrahedron method to the discrete
* eigenvalue spectrum in CELEN(NBANDD,NKPTS). EFERMI is calculated so
* that sum over occupation-numbers is equal to number of electrons
***********************************************************************

      SUBROUTINE DENTET(CELEN,WTKPT,NBANDS,NBANDD,NKPTS,DOS,DOSI,NEDOS,
     &                EMIN,EMAX,IDTET,NTET,VOLWGT,NELECT,EFERMI,FERWE,
     &                ECORR,JOB,IU6,PAR,DOSPAR,NKDIM,LDIMP,NIONS,JOBPAR)
      IMPLICIT COMPLEX (C)
      LOGICAL LOWB,HIGHB
      DIMENSION CELEN(NBANDD,NKPTS),FERWE(NBANDD,NKPTS),WTKPT(NKPTS)
      DIMENSION DOS(NEDOS),DOSI(NEDOS),IDTET(0:4,NTET)
      DIMENSION PAR(NBANDD,NKDIM,LDIMP,NIONS),DOSPAR(NEDOS,LDIMP,NIONS)

      DELTAE=(EMAX-EMIN)/(NEDOS-1)
C=======================================================================
C initialize arrays for dos and integr. dos
C=======================================================================

      IF (JOBPAR.NE.0) THEN
         DO 1 NI=1,NIONS
          DO 1 LP=1,LDIMP
           DO 1 I=1,NEDOS
    1    DOSPAR(I,LP,NI)=0.
      ENDIF
      DO 2 I=1,NEDOS
        DOS(I)=0.
    2 DOSI(I)=0.

C=======================================================================
C calculate dos and integrated dos
C=======================================================================

      CALL BZINTS(0,FERWE,CELEN,WTKPT,NBANDS,NBANDD,NKPTS,IDTET,NTET,
     C              VOLWGT,EMIN,EMAX,DOS,DOSI,NEDOS,EFERMI,SUMWEI,SUME,
     C                          100,PAR,DOSPAR,NKDIM,LDIMP,NIONS,JOBPAR)

C=======================================================================
C calculate approximated fermi energy
C=======================================================================

      DO 6 I=1,NEDOS
        IF (ABS(DOSI(I)-NELECT).LT.0.01.OR.DOSI(I).GT.NELECT) THEN
          GO TO 7
        ENDIF
    6 CONTINUE

    7 CONTINUE
      EFERMI= EMIN+(I-1)*DELTAE
      IF (JOB.EQ.0) RETURN

C=======================================================================
C search now for exact Fermi-level
C=======================================================================
      EF1= EMIN+(I-2)*DELTAE
      LOWB =.FALSE.
      EF2= EMIN+(I-1)*DELTAE
      HIGHB=.FALSE.

  100 EFERMI=(EF1+EF2)/2

C=======================================================================
C calculate fermi-weighting function, and their sum
C=======================================================================

      CALL BZINTS(JOB,FERWE,CELEN,WTKPT,NBANDS,NBANDD,NKPTS,IDTET,NTET,
     C               VOLWGT,EMIN,EMAX,DOS,DOSI,NEDOS,EFERMI,SUMWEI,SUME,
     C                          100,PAR,DOSPAR,NKDIM,LDIMP,NIONS,JOBPAR)
      ELECT=SUMWEI*2

C=======================================================================
C compare now with Number of Electrons
C=======================================================================
      IF ( ABS(ELECT-NELECT).LT.1E-10) GOTO 110
      IF ( (ABS(EF1-EF2)/(ABS(EFERMI)+1.E-10)).LT.1E-14) GOTO 120
      IF ( ELECT.GT.NELECT) THEN
        IF (.NOT.LOWB)  EF1=EF1-DELTAE
        HIGHB=.TRUE.
        EF2  =EFERMI
        GOTO 100
      ELSE
        IF (.NOT.HIGHB) EF2=EF2+DELTAE
        LOWB =.TRUE.
        EF1  =EFERMI
        GOTO 100
      ENDIF
  120 WRITE(*,*)' WARNING: DENTET: can`t reach specified precision'
      WRITE(*,*)' Number of Electrons is NELECT =',ELECT

  110 CONTINUE
* Final call to BZINTS (not really absolutely necessary ...) - can be
* commented out if no informational output/debugging desired ... !
      CALL BZINTS(JOB,FERWE,CELEN,WTKPT,NBANDS,NBANDD,NKPTS,IDTET,NTET,
     C               VOLWGT,EMIN,EMAX,DOS,DOSI,NEDOS,EFERMI,SUMWEI,SUME,
     C                          IU6,PAR,DOSPAR,NKDIM,LDIMP,NIONS,JOBPAR)

C=======================================================================
C How to calculate the correction term to the total Energy???? Is there
C a correction term at all ('no smearing', analytical interpolation and
C then integration with 'delta-function sampling'!!!) ?????????????????
C People say generally: NO! THERE IS NO ENTROPY! --> believe it or not!
C=======================================================================
      ECORR= 0

      RETURN
      END


********************* DELSTP    ****************************************
*
* Returns generalised delta and step functions (Methfessel & Paxton)
*
*  Input:
*      n > -1 : order of approximant; x : argument
*  Output:
*      D_n (x) ,  S_n (x)
*  Remarks:
*      D_n (x) = exp -x^2 * sum_i=0^n A_i H_2i(x)
*      S_n (x) = (1 - erf x)/2 + exp -x^2 * sum_i=1^n A_i H_{2i-1}(x)
*      where H is a Hermite polynomial and
*      A_i = (-1)^i / ( i! 4^i sqrt(pi) )
*
************************************************************************

      SUBROUTINE DELSTP(N,X,D,S)

C=======================================================================
C  Check against overflow / numerical problems ... :
C=======================================================================

      IF (N.GT.10) THEN
         WRITE(*,*)
     &      'DELSTP: Are you crazy? N>10! Danger of numerical problems!'
         WRITE(*,*)
     &      '        High order does not always mean high precision ...'
         WRITE(*,*)
     &      '        (The machine has only finite precision!) STOPPING!'
         STOP
      END IF
      IF (X.LT.-1.E5) THEN
         D=0.
         S=0.
         RETURN
      END IF
      IF (X.GT.1.E5) THEN
         D=0.
         S=1.
         RETURN
      END IF

C=======================================================================
C  If n < 0 : assume Gaussian type smearing
C  (must return  same as N=0 or ... )
C=======================================================================
      IF (N.LT.0) THEN
         D=EXP(-(X*X))/(SQRT(4.*ATAN(1.)))
         S=0.5+0.5*ERRF(X)
         RETURN
      END IF

C=======================================================================
C Methfessel & Paxton
C=======================================================================

      EX2=EXP(-(X*X))
      S0=0.5*ERRF(X)
      A=1./(SQRT(4.*ATAN(1.)))
      K=0
      H1=1.
      H2=2.*X
      S=0.
      D=A
      DO 1 I=1,N
         A=A/((-4.)*I)
         K=K+1
         H3=H1
         H1=H2
         H2=2.*X*H2-2*K*H3
         S=S+A*H1
         K=K+1
         H3=H1
         H1=H2
         H2=2.*X*H2-2*K*H3
         D=D+A*H1
    1 CONTINUE
      D=D*EX2
      S=0.5+S0-S*EX2
      RETURN
      END
