***************************************************************
*
*     Programm zum zeichen vom Bandstruktur
*
***************************************************************
                                           
      PROGRAM PLOTBAND

      CHARACTER NAME*40,HEAD*40,DTXT1*40,DTXT2*40,LABEL*40
      PARAMETER (NDIR=8,NBANDDIM=499,NNDIM=34,NPRODIM=11)
      DIMENSION STEP(NDIR+1),FE(NDIR*NNDIM,NBANDDIM*NPRODIM),XP(NNDIM)
      DIMENSION FEM(NDIR*NNDIM,2*NBANDDIM)
      CHARACTER*10 TEXT(NDIR+1)
      DIMENSION QBEG(3),QEND(3)
      DIMENSION DSH1(3),DSH2(3),DSH3(3)

 
      WRITE(*,*) 'PROGRAM PLOTBAND: zeichnet Bandstrucktur' 
      WRITE(*,*) 'Plotlabel:'
      READ(*,'(A)') LABEL

C-----Beschriftung einlesen
      OPEN(1,FILE='BANDCTR',STATUS='OLD',ERR=100)
      READ(1,'(A)') NAME
      READ(1,*) ND
      READ(1,*) NN
      DO 20 I=1,ND
        READ(1,*) TEXT(I),STEP(I)
        READ(1,*) QBEG(1),QBEG(2),QBEG(3)
        READ(1,*) QEND(1),QEND(2),QEND(3)
   20 CONTINUE
      STEP(ND+1)=0.
      READ(1,*) TEXT(ND+1)
      EFERMI=0.
      NT=0
      NPROJ=0
      READ(1,*,ERR=25,END=25) EFERMI
      READ(1,*,ERR=25,END=25) NT
      READ(1,*,ERR=25,END=25) ID1,ID2,ID3,RDUM1,RDUM2,NPROJ
   25 CLOSE(1)
      
C-----Art des Plots
      IF (NPROJ.EQ.0) THEN
         METHOD=0
         NPROJ=1
      ELSE
         WRITE(*,*) 'Plot all bands (0), just min/max (1) '//
     &         'or min/max with quadratic interpolation and'         
         WRITE(*,*) 'periodic boundary (2) or with '//
     &         'no periodic boundary (3)'
         READ(5,*) METHOD
         IF ((METHOD.LT.0).OR.(METHOD.GT.3)) THEN
            WRITE(*,*) 'Invalid choice !'
            STOP
         ENDIF
         IF ((METHOD.EQ.2).OR.(METHOD.EQ.3)) THEN
            WRITE(*,*) 'EDIFF (for warning) ='
            READ(*,*) EDIFF
            WRITE(*,*)
            WRITE(*,*) 'WARNINGS (rel. to E(fermi)):'
            WRITE(*,*) 'what  Point1   Point2   Point3'//
     &                 '   E(old)   E(new)   DE      kPt Band kz'
         ENDIF
      ENDIF

C-----Bandstruktur einlesen 
      NPOINTS=ND*NN
      OPEN(1,FILE='EIGENVAL',STATUS='OLD',ERR=100)  

      READ(1,*) NDUM1,NDUM2,NDUM3,NDUM4
      READ(1,*) RDUM1,RDUM2,RDUM3,RDUM4,RDUM5
      READ(1,*) RDUM6
      READ(1,'(A)') DTXT1
      READ(1,'(A)') DTXT2
      READ(1,*) NEL,NKPT,NBAND
      IF (NT.LE.0) NT=NEL/2+4
      NT=MIN(NT,NBAND)
      IF (NKPT.NE.NPOINTS*NPROJ) THEN
         WRITE(*,*) 'Error on input: ND*NN*NPROJ from file BAND does ',
     &              'not equal NKPT from EIGENVAL'
         WRITE(*,*) ND*NN*NPROJ, NKPT
         STOP
      ENDIF
      EFTEST=-1E30
      DO 30 I=1,NPOINTS
      DO 27 NB=1,NBAND
         FEM(I,NB*2-1)=100.
         FEM(I,NB*2)=-100.
27    CONTINUE  
      DO 30 NP=0,NPROJ-1
C fuer EIGENVAL aus OUTCAR
C         read(1,*)
C ende fuer EIGENVAL aus OUTCAR
         READ(1,*)
         READ(1,*)
         IF (NT.GE.NBAND) NT=NBAND
         
         DO 35 NB=1,NBAND
            READ(1,*) NCOUNT,EIGEN
            IF (NB.LE.NT) THEN
               FE(I,NT*NP+NB)=EIGEN
               FEM(I,2*NB-1)=MIN(FEM(I,2*NB-1),EIGEN)
               FEM(I,2*NB)  =MAX(FEM(I,2*NB),EIGEN)
            ENDIF
	    IF (NB.EQ.(NEL/2)) EFTEST=MAX(EFTEST,EIGEN)
   35    CONTINUE
   30 CONTINUE 
      IF (EFERMI.LT.-1E10) EFERMI=EFTEST

C calculate quadratic interpolation
      IF(METHOD.GE.2) THEN
       DO I=1,NPOINTS
        DO NB=1,NT
         EMAX=FEM(I,2*NB)
         EMIN=FEM(I,2*NB-1)
         DO NP=0,NPROJ-1

C get the 3 Points E1, E2 and E3
          IF (NP.EQ.0) THEN
           IF(METHOD.EQ.2) THEN
            E1=FE(I,NT*(NPROJ-1)+NB)
           ELSE
            E1=FE(I,NT*(NP+1)+NB)
           ENDIF
          ELSE
           E1=FE(I,NT*(NP-1)+NB)
          ENDIF
          E2=FE(I,NT*NP+NB)
          IF (NP.EQ.NPROJ-1) THEN
           IF(METHOD.EQ.2) THEN
            E3=FE(I,NB)
           ELSE
            E3=E1
           ENDIF
          ELSE
           E3=FE(I,NT*(NP+1)+NB)
          ENDIF

          IF (E1.LE.E2.AND.E3.LE.E2) THEN
           ETEST=E2-(E3-E1)**2/8/(E3+E1-2*E2)
           IF ((ETEST-EMAX).GT.EDIFF) THEN
            WRITE (*,'(A,6F9.5,3I4)') ' MAX',E1-EFERMI,E2-EFERMI,
     &            E3-EFERMI,EMIN-EFERMI,ETEST-EFERMI,ETEST-EMIN,I,NB,NP
           ENDIF
           FEM(I,2*NB)=MAX(FEM(I,2*NB),ETEST)
          ELSE IF (E1.GE.E2.AND.E3.GE.E2) THEN
           ETEST=E2-(E3-E1)**2/8/(E3+E1-2*E2)
           IF ((EMIN-ETEST).GT.EDIFF) THEN
            WRITE (*,'(A,6F9.5,3I4)') ' MIN',E1-EFERMI,E2-EFERMI,
     &            E3-EFERMI,EMIN-EFERMI,ETEST-EFERMI,ETEST-EMIN,I,NB,NP
           ENDIF
           FEM(I,2*NB-1)=MIN(FEM(I,2*NB-1),ETEST)
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDIF

      OPEN(3,FILE='BBAND',STATUS='UNKNOWN')
      write(3,'(9(I5,F10.4))') ((i,FEM(i,n),i=1,npoints),n=1,2*nt)
      close(3)
      OPEN(3,FILE='BAND',STATUS='UNKNOWN')
      WRITE(3,'(9(I5,F10.4))') ((i,FE(I,N),I=1,NPOINTS),N=1,NT)
      CLOSE(3)


C-----maximalen x-Wert suchen       
      XMIN=0.
      XMAX=0.
      DO 40 I=1,ND
   40 XMAX=XMAX+STEP(I)
C-----maximum und minimum suchen 
      FMAX=-1000
      FMIN= 1000                                
      DO 50 I=1,NPOINTS
       DO 50 NB=1,NT
        DO 45 NP=0,NPROJ-1 
   45        FE(I,NB+NP*NT)=FE(I,NB+NP*NT)-EFERMI
           FEM(I,2*NB)=FEM(I,2*NB)-EFERMI
           FEM(I,2*NB-1)=FEM(I,2*NB-1)-EFERMI
           IF (FEM(I,2*NB).GT.FMAX) FMAX=FEM(I,2*NB)
           IF (FEM(I,2*NB-1).LT.FMIN) FMIN=FEM(I,2*NB-1)
   50 CONTINUE  
      FMIN=FMIN-.5
      FMAX=FMAX+.5
C      FMIN=-23.2
C      FMAX=+7.2
C      FMIN=FMIN-0.07*(FMAX-FMIN)

      
C-----initialisieren 
      PXMAX=24.
      PYMAX=17.      
      CALL INIT
      CALL OPGSEG(NAME(1:5)//' ELEK')

      CALL READIN(PXMAX,PYMAX,XLEFT,YBOTT,XRIGHT,YTOP,ITEXT,
     &            ' ',' ',
     &            XMIN,XMAX,FMIN,FMAX,
     &            IDSH,DSH1,DSH2,DSH3,CHO1,CHO2)
                
C-----ACHSEN ZEICHENEN
C-----BESCHRIFTEN
      IF (ITEXT.NE.0) THEN
      CALL SHEAD(1,PYMAX,CHO1,' ')
      CALL PLTEXT(LABEL(1:40),40)
      ENDIF

C-----ACHSEN ZEICHENEN
      CALL HISUBF(XLEFT,YBOTT,
     &            PXMAX-XRIGHT-XLEFT,PYMAX-YTOP-YBOTT-3*CHO1)
      CALL XBOUND(0.,XMAX)
      CALL YBOUND(FMIN,FMAX)
      CALL DRWYAX
      CALL NODIGI
      CALL SETTCP(0.,0,0.)
      CALL SETTCL(0.,0.,0.)
      CALL DRWXAX
      CALL MKORIG
      CALL PLFRAM

C-----y-Achse beschriften
C-----zwischenlinien zeichen   
      X=0
      CALL SETTHI(CHO2)
      DO 60 I=1,ND+1 
        CALL MOVET(X,FMIN)
        CALL XTEXT(TEXT(I),DELTA)
        CALL MOVED(-0.5*DELTA,-1.)
        CALL SETTHI(CHO2)
        CALL PLTEXT(TEXT(I),10)
        CALL MOVET(X,FMIN)
        CALL DRAWT(X,FMAX) 
        X=X+STEP(I)
   60 CONTINUE
C      CALL SETTHI(CHO1)
C      CALL XTEXT(LABEL,DELTA)
C      CALL MOVET(X,FMIN)
C      CALL MOVED(-1.8*DELTA,0.3)
C      CALL SETTHI(CHO1)
C      CALL PLTEXT(LABEL,10)

C-----Punkte zeichnen 
      X=0
      DO 70 I=1,ND
        DO 170 M=1,NN
  170     XP(M)=X+(M-1)*STEP(I)/(NN-1)
        MODEDRAW=1
        DO 270 NB=1,NT
          IF (METHOD.EQ.0) THEN
             DO 180 NP=0,NPROJ-1
  180          CALL FITCRV(XP,FE((I-1)*NN+1,NT*NP+NB),NN,MODEDRAW)
          ELSE
             CALL FITCRV(XP,FEM((I-1)*NN+1,2*NB-1),NN,MODEDRAW)
C im Original von Andreas stand ...,2*NB+2),NN,... ???!!!???
             CALL FITCRV(XP,FEM((I-1)*NN+1,2*NB),NN,MODEDRAW+1)
	     DO 181 II=1,NN
	       CALL MOVET(XP(II),FEM((I-1)*NN+II,2*NB-1))
	       CALL DRAWT(XP(II),FEM((I-1)*NN+II,2*NB))
	       CALL MOVET(XP(II)+0.06,FEM((I-1)*NN+II,2*NB))
	       CALL DRAWT(XP(II)+0.06,FEM((I-1)*NN+II,2*NB-1))
 	       CALL MOVET(XP(II)-0.06,FEM((I-1)*NN+II,2*NB-1))
               CALL DRAWT(XP(II)-0.06,FEM((I-1)*NN+II,2*NB))
  181        CONTINUE
          ENDIF   
  270   CONTINUE
      X=X+STEP(I)
   70 CONTINUE
      CALL PLOTCL
      GOTO 1000

  100 WRITE(*,*)'ERROR: InitFile BANDCTR oder EIGENVAL existiert nicht'
      STOP     
 1000 CONTINUE
      END     


      SUBROUTINE XTEXT(TEXT,DELTA)
      CHARACTER TEXT*10

      DO 10 I=10,1,-1
        IF (TEXT(I:I).NE.' ') GOTO 20
   10 CONTINUE
   20 CONTINUE
 
      CALL FTXEXT(' ',1,DELTAX1,DELTAY) 
      CALL FTXEXT(' '//TEXT,I+1,DELTAX2,DELTAY) 
      DELTA=DELTAX2-DELTAX1
      RETURN 
      END









