********************************************************************
*
*   program to draw DOS
*   written by G. Kresse  version Dez 94
*
*
*
*
* !!!! YOU NEED THE ERLGRAPH-PACKAGE, WHICH IS NOT FREEWARE !!!
*  -> You can take a look at this program and adapt it for
*     your needs
*
*
*
*
*
*
*   reads the DOSCAR file and plots the density of states
*   the first line of the DOSCAR file controls to some extend the
*   behaviour of the program
*   the first line is read using the command
*   READ(10,*,ERR=20) NIONS,NATA,JOBPAR,KBLOCKR
*  
*   partial density of states in plotted if JOBPAR=1 or JOBPAR=2
*   (JOBPAR determines the format of the DOSCAR file
*    only format 1 and 2 are compatibel)
*   0   no partial density on file
*   1   partial and total density are shown on one plot
*   2   partial and total density are shown on the same plot
*
*   KBLOCKR determines wether sub averages are caclulated
*   an average over KBLOCKR datasets is plotted
*
*   NATA is currently unused
* 
*********************************************************************

      PROGRAM DRAWDO
      PARAMETER (NDOSD=1001,LDIMP=3)
      DIMENSION E(NDOSD),DOS(NDOSD,LDIMP+1),DOSI(NDOSD,LDIMP+1)
      DIMENSION SDOS(NDOSD,LDIMP+1),SDOSI(NDOSD,LDIMP+1)
      DIMENSION EEXP(NDOSD),DEXP(NDOSD)
      DIMENSION DSH1(3),DSH2(3),DSH3(3)
      CHARACTER TYPO*8,ATART*40
      CHARACTER SZEXP*40
      DATA IFIRST,PLOT,LABORT /0,0,.FALSE./
      LOGICAL LMEAN,LPARTIAL,LABORT

      WRITE(*,*)'Program DRAWDOS'

C init is necessary to initialize erlgraf on some machines 
C comment out if you have a version which needs no initialization
      CALL INIT
C--------------------------------------------------------------------
C read experimental data
C--------------------------------------------------------------------
      NEXP=1
      OPEN(21,FILE='DOSEXP',STATUS='OLD',ERR=510)
      READ(21,*) SZEXP,SCEXP
      READ(21,*)
      READ(21,*)
      DO 500 NEXP=1,NDOSD
        READ(21,*,END=520,ERR=520) EEXP(NEXP),DEXP(NEXP)
        DEXP(NEXP)=DEXP(NEXP)*SCEXP
  500 CONTINUE
  520 CLOSE(21)
      WRITE(*,*)SZEXP
      WRITE(*,*)NEXP,' experimental data read in'
  510 NEXP=NEXP-1
C--------------------------------------------------------------------
C     read DOS
C--------------------------------------------------------------------
      OPEN(10,FILE='DOSCAR',STATUS='OLD')
      READ(10,*,ERR=20) NIONS,NATA,JOBPAR,KBLOCKR
      IF (JOBPAR.EQ.0) THEN 
        IPAR=1
        WRITE(*,*)'no partial DOS on file'
      ELSE
        IPAR=4
        WRITE(*,*)'partial DOS on file'
      ENDIF

   20 READ(10,*) RHO,CL
      READ(10,*) TEMP
      READ(10,'(A40)') TYPO
      READ(10,'(A40)') ATART

      NDOSS=0
      DO 110 J=1,IPAR
      DO 110 I=1,NDOSD
        SDOS(I,J) =0
        SDOSI(I,J)=0
  110 CONTINUE
C--------------------------------------------------------------------
C     read DOS and build mean values of KBLOCK's
C--------------------------------------------------------------------
  200 CONTINUE
      PLOT=PLOT+1

C     first dataset is the total DOS even if partial DOS follows
C     therefore set KBLOCK to 1 for first dataset
C               and don't sum up a total DOS
C     for partial DOS multiply DOS on file with NIONS

      KBLOCK=KBLOCKR
      LMEAN =.TRUE.
      LPARTIAL=.FALSE.

      IF (JOBPAR.NE.0 .AND. IFIRST.NE.0) THEN
        LPARTIAL=.TRUE.
        WRITE(*,*)'reading partial DOS from ion',
     &   (INT(PLOT)-1)*KBLOCK+1,'to' ,INT(PLOT)*KBLOCK+1
      ENDIF
      IF (JOBPAR.NE.0 .AND. IFIRST.EQ.0) THEN 
        KBLOCK=1
        LMEAN=.FALSE.
        WRITE(*,*)'reading total DOS for the system'
        PLOT=0
      ENDIF
 
      WRITE(*,*) KBLOCK,LMEAN,LPARTIAL
      
      DO 100 J=1,IPAR
      DO 100 I=1,NDOSD
        DOS(I,J) =0
        DOSI(I,J)=0
  100 CONTINUE

      WEIGHT=1

C--------------------------------------------------------------------
C  read in dos 
C--------------------------------------------------------------------
      EFMAX=0
      WEIGHTS=0

      DO 300  K=1,KBLOCK
        EFERMI=0
        READ(10,*,END=400,ERR=400) EMAX,EMIN,NDOS,EFERMI,WEIGHT
        IF (EFMAX.EQ.0) EFMAX=EFERMI
        WRITE(*,*)'Block ',K,'read in'

 410    SCALE=(EMAX-EMIN)/(NDOS-1)
        NSKIP=1+NDOS/NDOSD
        IND=1
        WEIGHTS=WEIGHTS+WEIGHT
C
C  total DOS no partial information
C
      IF (.NOT. LPARTIAL) THEN
        DO 30 I=1,NDOS
          READ(10,*) ES,DOSS,DOSIS

          IF (MOD(I,NSKIP).EQ.0) THEN
            E(IND)   =ES
            DOS(IND,1) =DOSS /NIONS*WEIGHT+ DOS(IND,1)
            DOSI(IND,1)=DOSIS/NIONS*WEIGHT+ DOSI(IND,1)
            IND=IND+1
          ENDIF
   30   CONTINUE
C
C  partial DOS
C
      ELSE
        DO 50 I=1,NDOS
          READ(10,*) ES,DOSS,DOSP,DOSD
          IF (MOD(I,NSKIP).EQ.0) THEN
            E(IND)   =ES
            DOS(IND,1) =(DOSS+DOSP+DOSD)*WEIGHT+ DOS(IND,1)
            DOS(IND,2) =DOSS *WEIGHT+ DOS(IND,2)
            DOS(IND,3) =DOSP *WEIGHT+ DOS(IND,3)
            DOS(IND,4) =DOSD *WEIGHT+ DOS(IND,4)
            IND=IND+1
          ENDIF
   50   CONTINUE
      ENDIF

  300 CONTINUE

      NDOS=IND-1
C--------------------------------------------------------------------
C  mean value
C--------------------------------------------------------------------
      IF (LMEAN) THEN
        NDOSS=NDOSS+1
        DO 140 J=1,IPAR
        DO 140 I=1,NDOS
          DOS(I,J)  =DOS(I,J) /WEIGHTS
          DOSI(I,J) =DOSI(I,J)/WEIGHTS
          SDOS(I,J) =SDOS(I,J)+DOS(I,J)
          SDOSI(I,J)=SDOSI(I,J)+DOSI(I,J)
  140   CONTINUE
      ENDIF
C--------------------------------------------------------------------
C  plot DOS relativ to fermi-level
C--------------------------------------------------------------------
      DO 145 I=1,NDOS
        E(I)    =E(I)-EFMAX
 145  CONTINUE

      EMAX=EMAX-EFMAX
      EMIN=EMIN-EFMAX

      EFERMI=EFERMI-EFMAX
      EFMAX=0
C--------------------------------------------------------------------
C  determine minimum maximum values
C--------------------------------------------------------------------
  630 DMAX= 0.0
      DMAX2=0.0

      DO 40 I=1,NDOS
        DMAX=MAX(DOS(I,1),DMAX)
        DMA2X=MAX(DOSI(I,1),DMAX2)
   40 CONTINUE
      DMIN=0.0
      DMAX=DMAX*1.2

      JPAR=0
C--------------------------------------------------------------------
C  read PLOPINI
C--------------------------------------------------------------------
 610  PXMAX = 24.
      PYMAX = 17.
      CALL READIN(PXMAX,PYMAX,XLEFT,YBOTT,XRIGHT,YTOP,ITEXT,
     &            'n(E) (states/eV atom)','E (eV)',
     &            EMIN,EMAX,DMIN,DMAX,
     &            IDSH,DSH1,DSH2,DSH3,CHO1,CHO2)
      IF (IFIRST.EQ.0) THEN
        IF (DSH2(1).EQ.1) THEN
        WRITE(*,*)'smoothed DOS will be displayed'
        ELSE  IF (DSH2(1).EQ.2) THEN
        WRITE(*,*)'smoothed and unsmoothed DOS will be displayed'
        ENDIF
        IFIRST=1
      ENDIF
C--------------------------------------------------------------------
C  text
C--------------------------------------------------------------------
      CALL HISUBF(XLEFT,YBOTT,
     &            PXMAX-XRIGHT-XLEFT,PYMAX-YTOP-YBOTT-3*CHO1)

      CALL XBOUND(EMIN,EMAX)
      CALL YBOUND(DMIN,DMAX)
      CALL DRWAX
      CALL PLFRAM

      CALL MOVET(EFMAX,DMIN)
      CALL DRAWT(EFMAX,DMAX)

C      CALL MOVET(EFERMI-EFMAX,DMIN)
C      CALL DASHT(EFERMI-EFMAX,DMAX)

      IF (ITEXT.NE.0) THEN
        CALL MOVET(EMIN,DMAX)
        CALL MOVED(CHO1,-CHO1*1.5)
        CALL PLNUMB(CHO1,0.0,PLOT,-1)
      ENDIF

      IF (ITEXT.NE.0) THEN
        CHOS=CHO2*1.4
        CALL SETTHI(CHO2)
        CALL SHEAD(1,PYMAX,CHOS,'N=')
        CALL PLNUMB(CHO2,0.,REAL(NIONS),-1)
        CALL PLTEXT(' Typ=',5)
        CALL PLTEXT(TYPO,8)
        CALL PLTEXT('; ',2)
        CALL PLTEXT(ATART,20)
        WRITE(*,*)ATART
        CALL PLTEXT('; &1r&0=',8)
        CALL PLNUMB(CHO2,0.,RHO,-1)

        CALL SHEAD(2,PYMAX,CHOS,'T=')
        CALL PLNUMB(CHO2,0.,TE,0)
        IF (LABORT) CALL PLTEXT('Mittel ueber Plots',18)
      ENDIF
      CALL HILIMT
C--------------------------------------------------------------------
C     plot DOS
C--------------------------------------------------------------------
      IDSHA=IDSH
      CALL SETDSH(DSH1(1),DSH1(2),DSH1(3))
            
  600 JPAR=JPAR+1
      IF (LPARTIAL) THEN
        IDSHA=1
        IF (JPAR.EQ.1) THEN
          IDSHA=1
        ELSE IF (JPAR.EQ.2) THEN
          IDSHA=2
          CALL SETDSH(0.3,0.3,0.3)
        ELSE IF (JPAR.EQ.3) THEN
          IDSHA=2
          CALL SETDSH(0.1,0.1,0.1)
        ELSE IF (JPAR.EQ.4) THEN
          IDSHA=2
          CALL SETDSH(0.3,0.3,0.1)
        ENDIF
      ENDIF
  
C   unsmoothed  DOS
      IF (DSH2(1).EQ.0.OR.DSH2(1).EQ.2) THEN
        CALL POLYCV(E,DOS(1,JPAR),NDOS,IDSHA)
      ENDIF

C   smoothed DOS
      IF (DSH2(1).EQ.1.OR.DSH2(1).EQ.2) THEN
        CALL SETGLN(INT(DSH2(2)),INT(DSH2(3)))
        CALL SMOOTH(E,DOS(1,JPAR),NDOS)
        CALL POLYCV(E,DOS(1,JPAR),NDOS,IDSHA)
      ENDIF
C
C  partial DOS next l-dataset
C 
      IF (LPARTIAL.AND.JOBPAR.EQ.1 .AND. JPAR.LT. IPAR) GOTO 600
      IF (LPARTIAL .AND. JPAR.LT. IPAR) GOTO 610
               
C   experimental datas
      IF (NEXP.NE.0) THEN
        CALL SETSYM (DSH3(2),0.,INT(DSH3(1)))
        CALL POLYMT(EEXP,DEXP,NEXP)
      ENDIF

      CALL PLOTCL         
C     if abort jump to end
      IF (LABORT) GOTO 650
C
C  read next DOS / partial DOS
C
      GOTO 200

C====================================================================
C     plot mean values of all plots
C====================================================================
  400 CONTINUE
C     jump to end
      IF (NDOSS.EQ.0.OR.NDOSS.EQ.1) GOTO 650
            
      DO 120 J=1,IPAR
      DO 120 I=1,NDOS
        DOS(I,J) =SDOS(I,J)/NDOSS
        DOSI(I,J)=SDOSI(I,J)/NDOSS
  120 CONTINUE
      LABORT=.TRUE.
      
      GOTO  630

C     end of program
  650 CONTINUE

      END
