******************* PROGRAM GETDOS ***********************************
*  program for getting the dos from a set of EIGENVAL and PROCAR
*  files
*  usually this program is executed alongsided the shellscript
*  rundos
*  first the program reads the KPOINTS and INCAR files
*  than all EIGENVAL.nn nn=0...number of kpoints are loaded
*  and the total DOS and the bendstructure energy are calculated
*  if PROCAR.nn files are availible partial DOS might be calculated
*  as well 
*  
**********************************************************************

      PROGRAM GETDOS
      PARAMETER(NBANDM=1001,NKDIM= 501,NKBNDM=10001,NIONM=129)
      PARAMETER(NTETD=18000,NEDOSM=1001,LDIMP=3,TINY=1.E-6)
      CHARACTER*40 HEAD,TYPE
      CHARACTER*80 HEADER
      CHARACTER*1  CHARAC
      LOGICAL LTET,LFERMI,LOPEN,LDUM
      COMPLEX CELEN,CDUM
      DIMENSION VKPT(3,NKDIM),WTKPT(NKDIM),VKP(3),CELEN(NKBNDM)
      DIMENSION FERWE(NKBNDM),DOS(NEDOSM),DOSI(NEDOSM),HEADER(5)
      DIMENSION PAR(NKBNDM*LDIMP*NIONM),DOSPAR(NEDOSM*LDIMP*NIONM)
      DIMENSION PART(NKBNDM)
      DIMENSION IDTET(0:4,NTETD)

      LOPEN=.TRUE.
      LTET=.FALSE.
      LFERMI=.FALSE.
      ADJUST=1.E-3
      JOBPAR=0
      NTET=0
      NIONS=0
      EBOT =1.E30
      NEDOS=30001
      nedos=0
      ipar =0
      if (nedos.eq.0) then
         write(6,*) 'nedos?'
         read(5,*) nedos
      endif
      if (ipar.eq.0) then
         write(6,*) 'ipar?'
         read(5,*) ipar
      endif

      IF (NEDOS.GT.NEDOSM) THEN
         WRITE(*,*) 'NEDOS greater than NEDOSM, check ...'
         STOP
      ENDIF

      OPEN(20,FILE='INCAR',ERR=40000,STATUS='OLD')
      DO 5 I=1,27
         READ(20,'(A)',ERR=4000,END=4000) HEAD
    5 CONTINUE
      READ(20,*,ERR=4000,END=4000) EMIN,EMAX
      READ(20,*,ERR=4000,END=4000) SIGMA,ISMEAR
      CLOSE(20)
      GOTO 5000
 4000 CLOSE(20)
C=======================================================================
C  read INCAR file
C=======================================================================

      EMIN=10.
      EMAX=-10.
      SIGMA=0.2
      ISMEAR=-5
      CALL RDATAB(LOPEN,'INCAR',20,'EMIN','=','#',';','F',
     &            IDUM,EMIN,CDUM,LDUM,CHARAC,N,1,IERR)
      IF (((IERR.NE.0).AND.(IERR.NE.3)).OR.
     &                    ((IERR.EQ.0).AND.(N.LT.1))) THEN
         WRITE(IU0,*)'Error reading item ''EMIN'' from file INCAR.'
         GOTO 40000
      ENDIF
      CALL RDATAB(LOPEN,'INCAR',20,'EMAX','=','#',';','F',
     &            IDUM,EMAX,CDUM,LDUM,CHARAC,N,1,IERR)
      IF (((IERR.NE.0).AND.(IERR.NE.3)).OR.
     &                    ((IERR.EQ.0).AND.(N.LT.1))) THEN
         WRITE(IU0,*)'Error reading item ''EMAX'' from file INCAR.'
         GOTO 40000
      ENDIF
      CALL RDATAB(LOPEN,'INCAR',20,'ISMEAR','=','#',';','I',
     &            ISMEAR,RDUM,CDUM,LDUM,CHARAC,N,1,IERR)
      IF (((IERR.NE.0).AND.(IERR.NE.3)).OR.
     &                    ((IERR.EQ.0).AND.(N.LT.1))) THEN
         WRITE(IU0,*)'Error reading item ''ISMEAR'' from file INCAR.'
         GOTO 40000
      ENDIF
      CALL RDATAB(LOPEN,'INCAR',20,'SIGMA','=','#',';','F',
     &            IDUM,SIGMA,CDUM,LDUM,CHARAC,N,1,IERR)
      IF (((IERR.NE.0).AND.(IERR.NE.3)).OR.
     &                    ((IERR.EQ.0).AND.(N.LT.1))) THEN
         WRITE(IU0,*)'Error reading item ''SIGMA'' from file INCAR.'
         GOTO 40000
      ENDIF
 5000 CONTINUE
      LTET=((ISMEAR.LE.-4).OR.(ISMEAR.GE.30))
      IF (ISMEAR.EQ.-6) ISMEAR=-1
      IF (ISMEAR.GT.0) ISMEAR=MOD(ISMEAR,30)

C=======================================================================
C  read KPOINTS file
C=======================================================================
      OPEN(20,FILE='KPOINTS',ERR=10000,STATUS='OLD')
      READ(20,'(A)',ERR=10000,END=10000) HEAD
      READ(20,*,ERR=10000,END=10000) NKPTS
      IF (NKPTS.GT.NKDIM) THEN
         WRITE(*,*) 'NKPTS greater than NKDIM, check ...'
         STOP
      ENDIF
      READ(20,'(A)',ERR=10000,END=10000) TYPE
      WEISUM=0.
      DO 10 NK=1,NKPTS
         READ(20,*,ERR=10000,END=10000) (VKPT(I,NK),I=1,3),WTKPT(NK)
         WEISUM=WEISUM+WTKPT(NK)
   10 CONTINUE
      IF (LTET) THEN
         READ(20,'(A)',ERR=10000,END=10000) HEAD
         IF ((HEAD(1:1).NE.'T').AND.(HEAD(1:1).NE.'t')) GOTO 10000
         READ(20,*,ERR=10000,END=10000) NTET,VOLWGT
         IF (NTET.GT.NTETD) THEN
            WRITE(*,*) 'NTET greater than NTETD, check ...'
            STOP
         ENDIF
         DO 15 ITET=1,NTET
            READ(20,*,ERR=10000,END=10000) (IDTET(KTH,ITET),KTH=0,4)
   15    CONTINUE
      ENDIF
      CLOSE(20)

C=======================================================================
C  read EIGENVAL file
C=======================================================================
      OPEN(20,FILE='EIGENVAL',STATUS='OLD',ERR=20000)
      DO 20 I=1,5
         READ(20,'(A)',ERR=20000,END=20000) HEADER(I)
   20 CONTINUE
      READ(20,*,ERR=20000,END=20000) NELECT,NKPDUM,NBANDS
C      IF (NKPTS.NE.NKPDUM) GOTO 30000
      IF (NBANDS.GT.NBANDM) THEN
         WRITE(*,*) 'NBANDS greater than NBANDM, check ...'
         STOP
      ENDIF
      ICOUNT=0
      WRITE(*,*)'trying to read EIGENVAL file'
      DO 40 NK=1,NKPTS
         READ(20,'(A)',ERR=20000,END=20000) HEAD
         READ(20,*,ERR=20000,END=20000) VKP(1),VKP(2),VKP(3),WKP
* Not a perfect 'check' ...
         IF (((TYPE(1:1).EQ.'R').OR.(TYPE(1:1).EQ.'r')).AND.
     &         ((ABS(VKP(1)-VKPT(1,NK)).GT.TINY).OR.
     &          (ABS(VKP(2)-VKPT(2,NK)).GT.TINY).OR.
     &          (ABS(VKP(3)-VKPT(3,NK)).GT.TINY))) GOTO 30000
         DO 30 I=1,NBANDS
            ICOUNT=ICOUNT+1
            IF (ICOUNT.GT.NKBNDM) THEN
               WRITE(*,*) 'ICOUNT greater than NKBNDM, check ...'
            ENDIF
            READ(20,*,ERR=20000,END=20000) NDUM,EIGVAL
            EBOT=MIN(EBOT,EIGVAL)
            CELEN(ICOUNT)=EIGVAL
   30    CONTINUE
         WTKPT(NK)=WTKPT(NK)/WEISUM
   40 CONTINUE
      CLOSE(20)
      WRITE(*,*)'ok'

C=======================================================================
C  read PROCAR file
C=======================================================================
      WRITE(*,*)'trying to read PROCAR file'
      OPEN(20,FILE='PROCAR',ERR=1000)
      WRITE(*,*)'found PROCAR'
      READ(20,200,ERR=1000,END=1000) NKPDUM,NBDUM,NIONS     
C      IF ((NKPDUM.NE.NKPTS).OR.(NBDUM.NE.NBANDS)) GOTO 1000
      DO 70 NK=1,NKPTS
         READ(20,'(A1)',ERR=1000,END=1000) HEAD
         READ(20,201,ERR=1000,END=1000) IDUM,VKP(1),VKP(2),VKP(3),WKP
* Not a perfect 'check' ...
         IF (((TYPE(1:1).EQ.'R').OR.(TYPE(1:1).EQ.'r')).AND.
     &      ((ABS(VKP(1)-VKPT(1,NK)).GT.TINY).OR.
     &       (ABS(VKP(2)-VKPT(2,NK)).GT.TINY).OR.
     &       (ABS(VKP(3)-VKPT(3,NK)).GT.TINY))) GOTO 1000
         READ(20,'(A1)',ERR=1000,END=1000) HEAD
         READ(20,'(A1)',ERR=1000,END=1000) HEAD
         DO 60 I=1,NBANDS
            READ(20,203,ERR=1000,END=1000) NDUM,EIGVAL,FERWGT,IDUM,
     &         (PAR((J*NKPTS+(NK-1))*NBANDS+I),J=0,LDIMP-1),RDUM
            IF (ABS(EIGVAL-REAL(CELEN(I+(NK-1)*NBANDS))).GT.1E-3)
     &                                                       GOTO 1000
            CELEN(I+(NK-1)*NBANDS)=EIGVAL
            DO 50 NI=1,NIONS-1
               READ(20,204,ERR=1000,END=1000) IDUM,
     &         (PAR(((NI*LDIMP+J)*NKPTS+(NK-1))*NBANDS+I),J=0,LDIMP-1),
     &         RDUM
   50       CONTINUE
            IF (NIONS.GT.1) THEN
               READ(20,'(A1)',ERR=1000,END=1000) HEAD
               READ(20,'(A1)',ERR=1000,END=1000) HEAD
            ENDIF
   60    CONTINUE
   70 CONTINUE
      WRITE(*,*)'ok'
      CLOSE(20)
      JOBPAR=1
      IF (ipar.eq.1) JOBPAR=2
      IF (ipar.eq.2) JOBPAR=3
  200 FORMAT(14X,I5,20X,I4,19X,I4)
  201 FORMAT(9X,I4,5X,3F11.8,14X,F10.8)
  203 FORMAT(3X,I3,2X,F14.8,3X,F10.8,3X,I3,2X,3(1X,F10.8),2X,F6.3)
  204 FORMAT(38X,I3,2X,3(1X,F10.8),2X,F6.3)
 1000 CLOSE(20)

      WRITE(*,'(A,I5,A,I5,A,I4,A)') 'Found ',NKPTS,' kpoints, ',
     &                 NTET,' tetrahedra and ',NBANDS,' bands ...'
      WRITE(*,'(A,I5,A,F12.6,$)') 'ISMEAR = ',ISMEAR,', SIGMA =',SIGMA
      IF (LTET) THEN
         WRITE(*,'(A)') ', using tetrahedron method ...'
      ELSE
         WRITE(*,*)
      ENDIF
C=======================================================================
C  scale to 1
C=======================================================================
      IF (.TRUE.) THEN
      DO 1370 NK=1,NKPTS
         DO 1360 I=1,NBANDS
            SUM =0
            SUM2=0
            DO 1350 NI=0,NIONS-1
            TMP=0
            DO 1340 J=0,LDIMP-1
               TMP=TMP+PAR(((NI*LDIMP+J)*NKPTS+(NK-1))*NBANDS+I)
 1340       CONTINUE
            SUM=SUM+TMP
            SUM2=SUM2+TMP*TMP
 1350       CONTINUE
C  normalize to 1
            SC=1/SUM
            DO 1355 NI=0,NIONS-1
            TMP=0
            DO 1345 J=0,LDIMP-1
               PAR(((NI*LDIMP+J)*NKPTS+(NK-1))*NBANDS+I)=
     &         PAR(((NI*LDIMP+J)*NKPTS+(NK-1))*NBANDS+I)*SC
 1345       CONTINUE
            SUM=SUM+TMP
            SUM2=SUM2+TMP*TMP
 1355       CONTINUE
 1360    CONTINUE
 1370 CONTINUE
      ENDIF
C=======================================================================
C  calculate DOS (optionally partial DOS)
C=======================================================================

      IF (EMAX.LT.EMIN)
     & CALL DENSTA(CELEN,WTKPT,NBANDS,NBANDS,NKPTS,DOS,DOSI,NEDOS,EMIN,
     &         EMAX,ISMEAR,ABS(SIGMA),NELECT,EFERMI,FERWE,EENTRO,IDTET,
     &             NTET,VOLWGT,LTET,100,PAR,DOSPAR,NKPTS,LDIMP,NIONS,0)

      DELTAE=(EMAX-EMIN)/(NEDOS-1)
      IF (DELTAE.LT.ADJUST) THEN
         EFERMI=ADJUST*INT(EFERMI/ADJUST)
         EMIN  =ADJUST*INT(EMIN  /ADJUST)
         EMAX  =ADJUST*INT(EMAX  /ADJUST)
         DELTAE=MAX(ADJUST*INT(DELTAE/ADJUST+0.5),1E-3)
         NEDOS=NINT((EMAX-EMIN)/DELTAE)+1
      ENDIF
      IF (JOBPAR.EQ.1 .OR. JOBPAR.EQ.2 .OR. JOBPAR.EQ.0) THEN
      IF (JOBPAR.EQ.1) WRITE(*,*) 'calculating also partial DOS'
      IF (JOBPAR.EQ.2) WRITE(*,*) 'calculating ionsummed partial DOS'
      CALL DENSTA(CELEN,WTKPT,NBANDS,NBANDS,NKPTS,DOS,DOSI,NEDOS,EMIN,
     &        EMAX,ISMEAR,ABS(SIGMA),NELECT,EFERMI,FERWE,EENTRO,IDTET,
     &          NTET,VOLWGT,LTET,6,PAR,DOSPAR,NKPTS,LDIMP,NIONS,JOBPAR)
      ENDIF
C=======================================================================
C  calculate partitipation ratio
C=======================================================================
      IF (JOBPAR.EQ.3) THEN
      WRITE(*,*) 'Calculating also partitipation ratio'
      DO 370 NK=1,NKPTS
         DO 360 I=1,NBANDS
            SUM =0
            SUM2=0
            DO 350 NI=0,NIONS-1
            TMP=0
            DO 340 J=0,LDIMP-1
               TMP=TMP+PAR(((NI*LDIMP+J)*NKPTS+(NK-1))*NBANDS+I)   
  340       CONTINUE
            SUM=SUM+TMP
            SUM2=SUM2+TMP*TMP
  350       CONTINUE
            PART((NK-1)*NBANDS+I)=SUM/SUM2
  360    CONTINUE
  370 CONTINUE

      CALL DENSTA(CELEN,WTKPT,NBANDS,NBANDS,NKPTS,DOS,DOSI,NEDOS,EMIN,
     &        EMAX,ISMEAR,ABS(SIGMA),NELECT,EFERMI,FERWE,EENTRO,IDTET,
     &        NTET,VOLWGT,LTET,6,PART,DOSPAR,NKPTS,1,1,JOBPAR)
      
      ENDIF
C=======================================================================
C  write DOS
C=======================================================================
      OPEN(20,FILE='DOSCAR')
      DO 80 I=1,5
         WRITE(20,'(A)') HEADER(I)
   80 CONTINUE
      IF (LFERMI) THEN
         EMIN=EMIN-EFERMI
         EMAX=EMAX-EFERMI
      ENDIF
      IF (LFERMI)      WRITE(20,*) EMAX,EMIN,NEDOS,0.0   ,1.0
      IF (.NOT.LFERMI) WRITE(20,*) EMAX,EMIN,NEDOS,EFERMI,1.0
      DO 90 I=1,NEDOS
         E=EMIN+DELTAE*(I-1)
         IF (LFERMI) E=E-EFERMI
         WRITE(20,'(3X,F8.3,2E12.4)') E,DOS(I),DOSI(I)
   90 CONTINUE
      IF (JOBPAR.EQ.1) THEN
         DO 110 NI=0,NIONS-1
           IF (LFERMI)      WRITE(20,*) EMAX,EMIN,NEDOS,0.0   ,1.0
           IF (.NOT.LFERMI) WRITE(20,*) EMAX,EMIN,NEDOS,EFERMI,1.0
           DO 100 I=1,NEDOS
             E=EMIN+DELTAE*(I-1)
             IF (LFERMI) E=E-EFERMI
  100      WRITE(20,'(3X,F8.3,3E12.4)')
     &         E,(DOSPAR(I+(LPRO+NI*LDIMP)*NEDOS),LPRO=0,LDIMP-1)
  110    CONTINUE
      ELSE IF (JOBPAR.EQ.2) THEN 
           IF (LFERMI) E=E-EFERMI
           IF (LFERMI)      WRITE(20,*) EMAX,EMIN,NEDOS,0.0   ,1.0
           IF (.NOT.LFERMI) WRITE(20,*) EMAX,EMIN,NEDOS,EFERMI,1.0
           DO 320 LPRO=0,LDIMP-1
           DO 320 NI=1,NIONS-1
           DO 320 I=1,NEDOS
             DOSPAR(I+(LPRO+0*LDIMP)*NEDOS)=
     &        DOSPAR(I+(LPRO+0 *LDIMP)*NEDOS)+
     &        DOSPAR(I+(LPRO+NI*LDIMP)*NEDOS)
  320      CONTINUE
           NI=0
           DO 300 I=1,NEDOS
           E=EMIN+DELTAE*(I-1)
  300      WRITE(20,'(3X,F8.3,3E12.4)')
     &         E,(DOSPAR(I+(LPRO+NI*LDIMP)*NEDOS)/NIONS,LPRO=0,LDIMP-1)
      ELSE IF (JOBPAR.EQ.3) THEN 
      IF (LFERMI)      WRITE(20,*) EMAX,EMIN,NEDOS,0.0   ,1.0
      IF (.NOT.LFERMI) WRITE(20,*) EMAX,EMIN,NEDOS,EFERMI,1.0
      DO 390 I=1,NEDOS
         E=EMIN+DELTAE*(I-1)
         IF (LFERMI) E=E-EFERMI
         WRITE(20,'(3X,F8.3,2E12.4)') E,DOSPAR(I)/MAX(DOS(I),1E-1)
     &                  ,DOSPAR(I)
  390 CONTINUE
      ENDIF
      CLOSE(20)

      GOTO 99999

10000 WRITE(*,*) 'Error opening or reading file KPOINTS.'
      CLOSE(20)
      STOP
20000 WRITE(*,*) 'Error opening or reading file EIGENVAL.'
      CLOSE(20)
      STOP
30000 WRITE(*,*) 'Incompatible k-points on files.'
      STOP
40000 WRITE(*,*) 'Error opening or reading file INCAR.'
      CLOSE(20)
      STOP
99999 CONTINUE
      END


      SUBROUTINE ERROR(A,B,N)
* Prints some message and stops execution ... . This routine is needed
* for compatibility with packages SYMLIB and LATTLIB (J. Furthmueller)
      CHARACTER*(*) A,B
      WRITE(*,1) A,B,N
    1 FORMAT(//' VERY BAD NEWS! Error in subroutine',A,':'/,A,I8)
      STOP
      END
