************************************************************************
*  get structure and set up symmetry and k-points and tetrahedra ...
************************************************************************

      PROGRAM KPOINTS

      IMPLICIT COMPLEX (C)

C=======================================================================
C  all dimensional statments
C=======================================================================
      CHARACTER*255 LINE
      CHARACTER*40 SZNAMP,SZNAMK
      CHARACTER*1  CSEL

C-----Some parameters
      LOGICAL LOPEN,LSDYN,LSFOR
      PARAMETER (LOPEN=.TRUE.,IU0=0,IU6=6,IU5=5,ISYM=1)
      PARAMETER(NTYPD=11,NIOND=511,NKDIM=10001,NTETD=180001,IKPTD=201)
C-----Quantities related to the tetrahedron integration method
      LOGICAL LTET
      DIMENSION IDTET(0:4,NTETD),IKPT(IKPTD,IKPTD,IKPTD)
C-----k-points
      DIMENSION VKPT(3,NKDIM),VKPTL(3,NKDIM)
      DIMENSION WTKPT(NKDIM)
C-----Arrays for dynamics
      DIMENSION POSION(3,NIOND),POSIOC(3,NIOND),LSFOR(3,NIOND),
     &          D2(3,NIOND),D2C(3,NIOND),D3(3,NIOND),VEL(3,NIOND)
      DIMENSION NITYP(NTYPD),ITYP(NIOND),SNOSE(4),NETYP(NTYPD)
      DIMENSION VTMP(3)
C-----lattice-parameters
      DIMENSION A(3,3),B(3,3),ANORM(3),BNORM(3)
      DIMENSION AI(3,3),BI(3,3),ANORMI(3),BNORMI(3)
      COMMON /TYP/ NTYP,NITYP
C-----Symmetry related arrays
      INTEGER ROTMAP(NIOND,48,NIOND)
      DIMENSION TAU(NIOND,3),TAUROT(NIOND,3),WRKROT(3*(NIOND+2))
      DIMENSION PTRANS(NIOND+2,3),INDROT(NIOND+2),BK(3,3),SHIFT(3)
      COMMON /SYMM/ ISYMOP(3,3,48),NROT,IGRPOP(3,3,48),NROTK,
     C                            GTRANS(3,48),INVMAP(48),NPCELL,AP(3,3)

      LTET=.TRUE.
      IF (LOPEN) THEN
      OPEN(UNIT=15,FILE='POSCAR',STATUS='OLD')
      OPEN(UNIT=14,FILE='KPOINTS',STATUS='OLD')
      ENDIF

C=======================================================================
C  Read UNIT=15: POSCAR Startjob and Continuation-job
C  Format of UNIT=15
C   Header
C   k-points (in units of reciprocal lattice) &    weight of k-points
C   Optional Position of Ions
C   Optional Velocities
C   Optional for a Continuation job Predictorcoordinates
C=======================================================================

C-----Basis vectors and scaling parameter ('lattice constant')
      READ(15,'(A40)') SZNAMP
      READ(15,*) SCALE
      DO 70101 I=1,3
        READ(15,*) A(1,I),A(2,I),A(3,I)
70101 CONTINUE

      IF (SCALE.LT.0.) THEN
C----alternatively give a volume (=abs(scale)) and adjust the lengths of
C----the three lattice vectors to get the correct desired volume ... :
         CALL LATTIC(OMEGA,A,B,ANORM,BNORM,IU6)
         SCALE=(ABS(SCALE)/OMEGA)**(1./3.)
      ENDIF

      DO 70102 I=1,3
        A(1,I)=SCALE*A(1,I)
        A(2,I)=SCALE*A(2,I)
        A(3,I)=SCALE*A(3,I)
        AI(1,I)=A(1,I)
        AI(2,I)=A(2,I)
        AI(3,I)=A(3,I)
70102 CONTINUE

      CALL LATTIC(OMEGA,A,B,ANORM,BNORM,IU6)
      WRITE(*,'(A,F12.4/)') 'Cell volume is ',OMEGA

C-----number of atomes per type
      READ(15,'(A)') LINE
      NTYP=NWORDS(LINE)

      IF (NTYP.GT.NTYPD) THEN
        WRITE(IU0,*)'ERROR: increase NTYPD',NTYP
        STOP
      ENDIF

      WRITE(IU6,'(A,I5,A)')'Found ',NTYP,' atom types'
      READ(LINE,*) (NITYP(NT),NT=1,NTYP)
C---- Set up the table from which we get type of each ion
      NI=1
      DO 6130 NT=1,NTYP
      DO 6130 NI=NI,NITYP(NT)+NI-1
        ITYP(NI)=NT
 6130 CONTINUE

C-----Positions
      NIONS=0
      DO 6110 NT=1,NTYP
      NIONS=NIONS+NITYP(NT)
 6110 CONTINUE

      IF (NIONS.GT.NIOND) THEN
        WRITE(IU0,*)'ERROR: increase NIOND',NIONS
        STOP
      ENDIF

      READ(15,'(A1)') CSEL
      LSDYN=((CSEL.EQ.'S').OR.(CSEL.EQ.'s'))
      IF (LSDYN) READ(15,'(A1)') CSEL
      IF (CSEL.EQ.'K'.OR.CSEL.EQ.'k'.OR.
     &    CSEL.EQ.'C'.OR.CSEL.EQ.'c') THEN
        CSEL='K'
        WRITE(IU6,*)' positions in cartesian coordinates'
      ELSE
        WRITE(IU6,*)' positions in direct lattice'
      ENDIF

      DO 7008 NI=1,NIONS
      IF (LSDYN) THEN
      READ(15,*,ERR=400,END=400) POSION(1,NI),POSION(2,NI),POSION(3,NI),
     &                           LSFOR(1,NI),LSFOR(2,NI),LSFOR(3,NI)
      ELSE
      READ(15,*,ERR=400,END=400) POSION(1,NI),POSION(2,NI),POSION(3,NI)
      ENDIF
 7008 CONTINUE

      IF (CSEL.EQ.'K') THEN

        DO 7015 NI=1,NIONS
          POSION(1,NI)=SCALE*POSION(1,NI)
          POSION(2,NI)=SCALE*POSION(2,NI)
          POSION(3,NI)=SCALE*POSION(3,NI)
 7015   CONTINUE

        CALL KARDIR(NIONS,POSION,B)
      ENDIF
C-----also set POSIONC

      DO 450  NI=1,NIONS
        POSIOC(1,NI)=POSION(1,NI)
        POSIOC(2,NI)=POSION(2,NI)
        POSIOC(3,NI)=POSION(3,NI)
  450 CONTINUE

      INIT=0
      SNOSE(1)=1

      READ(15,'(A1)',ERR=422,END=410) CSEL
  422 IF (CSEL.EQ.'E' .OR. CSEL.EQ.'e') THEN
        READ(15,'(A)',ERR=410,END=410) LINE
        NTYPE=NWORDS(LINE)
        IF (NTYPE.GT.NTYPD) THEN
          WRITE(IU0,*)'ERROR: increase NTYPD',NTYPE
          STOP
        ENDIF
        READ(LINE,*) (NETYP(NT),NT=1,NTYPE)
        NEMPTY=0
        DO 423 NT=1,NTYPE
  423   NEMPTY=NEMPTY+NETYP(NT)
        DO 424 I=1,NEMPTY
          READ(15,'(A)',ERR=410,END=410) DUMX,DUMY,DUMZ
  424   CONTINUE
        READ(15,'(A1)',ERR=425,END=410) CSEL
      ENDIF
  425 IF (CSEL.EQ.'K'.OR.CSEL.EQ.'k'.OR.CSEL.EQ.' '
     &    .OR.CSEL.EQ.'C'.OR.CSEL.EQ.'c') THEN
        CSEL='K'
        WRITE(IU6,*)' velocities in cartesian coordinates'
      ELSE
        WRITE(IU6,*)' velocities in direct lattice'
      ENDIF
C-----if we have velocities, read them in and transform from
C     cartesian coordinates to direct lattice

      DO 420 NI=1,NIONS
        READ(15,*,ERR=410,END=410) VEL(1,NI),VEL(2,NI),VEL(3,NI)
        IF (CSEL.EQ.'K') THEN

        CALL  KARDIR(1,VEL(1,NI),B)
        VEL(1,NI)=VEL(1,NI)*POTIM
        VEL(2,NI)=VEL(2,NI)*POTIM
        VEL(3,NI)=VEL(3,NI)*POTIM
        ENDIF
  420 CONTINUE

C-----try to read in predictor Coordinates
      READ(15,*,ERR=430,END=430)
      READ(15,*,ERR=430,END=430) INIT

C-----if INIT is there and it is 1 we have predictor-coordinates on the
C-----file so we can start with them
      IF (INIT.EQ.0) GOTO 430
      READ(15,*) POTIMR
      IF (POTIMR.NE.POTIM) THEN
        WRITE(IU6,*)
        WRITE(IU6,*)' There are predictor-coordinates on the file.'
        WRITE(IU6,*)' we can''t use them due to change of POTIM!'
        GOTO 430
      ENDIF

C-----Read in Nose-Parameter
      READ(15,*) SNOSE
C-----Read in predictor-coordinates (always in direct lattice)
      READ(15,*) (POSION(1,NI),POSION(2,NI),POSION(3,NI),NI=1,NIONS)
      READ(15,*) (D2(1,NI),D2(2,NI),D2(3,NI),NI=1,NIONS)
      READ(15,*) (D3(1,NI),D3(2,NI),D3(3,NI),NI=1,NIONS)

      WRITE(IU6,*)
      WRITE(IU6,*)' Using predictor-coordinates on the file'

      GOTO 440

C-----set starting velocities and positions of ions
  400 WRITE(IU6,*)' No initial positions read in'
      INIT=1
  410 CONTINUE
      WRITE(IU6,*)' No initial velocities read in'

      DO 411 I=1,NIONS
         VEL(1,I)=0.
         VEL(2,I)=0.
         VEL(3,I)=0.
  411 CONTINUE

C-----------------------------------------------------------------------
C  Reading Inputfile 15 finished
C  if you end up at 430  INIT is set to 0,
C    INIT is used in the call to STEP  (predictors are not initialised)
C    in that way we tell STEP that it must initialize everything for us
C  if you end up at 440 INIT is 1 (predictors are initialised)
C----------------------------------------------------------------------
  430 CONTINUE
      INIT=0
  440 CONTINUE

C-----------------------------------------------------------------------
C  initialize the symmetry stuff
C-----------------------------------------------------------------------
      IF (ISYM.EQ.1) THEN
* Finite temperature allows no symmetry by definition ...
         CALL INISYM(A,POSION,VEL,LSFOR,LSDYN,NTYP,NITYP,NIOND,
     &             PTRANS,ROTMAP,TAU,TAUROT,WRKROT,INDROT,IU6)
      ELSE
* ... so take nosymm!
         CALL NOSYMM(A,NTYP,NITYP,NIOND,PTRANS,ROTMAP,IU6)
      END IF

C=======================================================================
C  Read UNIT=14: KPOINTS
C  number of k-points and k-points in reciprocal lattice
C=======================================================================

C-----K-points
      READ(14,'(A40)',ERR=70111,END=70111) SZNAMK
      IF (SZNAMK(1:1).EQ.'#') LTET=.FALSE.
      READ(14,*,ERR=70111,END=70111) NKPTS
      IF (NKPTS.GT.NKDIM) THEN
        WRITE(IU0,*)'ERROR: increase NKDIM'
        STOP
      ENDIF
      READ(14,'(A1)',ERR=70111,END=70111) CSEL
      IF (CSEL.EQ.'K'.OR.CSEL.EQ.'k'.OR.
     &    CSEL.EQ.'C'.OR.CSEL.EQ.'c') THEN
        CSEL='K'
        IF (NKPTS.GT.0) WRITE(IU6,*)' k-points in cartesian coordinates'
      ELSE
        IF (NKPTS.GT.0) WRITE(IU6,*)' k-points in reciprocal lattice'
      ENDIF

      IF (NKPTS.GT.0) THEN
* Read in a given set of arbitrary k-points:
         WSUM=0
         DO 7011 NKP=1,NKPTS
            READ(14,*,ERR=70111,END=70111)
     &                    VKPT(1,NKP),VKPT(2,NKP),VKPT(3,NKP),WTKPT(NKP)
            WSUM=WSUM+WTKPT(NKP)
 7011    CONTINUE

         IF (CSEL.EQ.'K') THEN

            DO 7013 NKP=1,NKPTS
               VKPT(1,NKP)=VKPT(1,NKP)/SCALE
               VKPT(2,NKP)=VKPT(2,NKP)/SCALE
               VKPT(3,NKP)=VKPT(3,NKP)/SCALE
               VKPTL(1,NKP)=VKPT(1,NKP)
               VKPTL(2,NKP)=VKPT(2,NKP)
               VKPTL(3,NKP)=VKPT(3,NKP)
 7013       CONTINUE

            CALL KARDIR(NKPTS,VKPT,A)
            CALL KARDIR(NKPTS,VKPTL,A)
         ENDIF

         DO 7012  NKP=1,NKPTS
            WTKPT(NKP)=WTKPT(NKP)/WSUM
 7012    CONTINUE

         IF (LTET) THEN
* Read in tetrahedra if you want to use tetrahedron method:
            READ(14,'(A)',ERR=70111,END=70111) CSEL
            IF (CSEL.NE.'T' .AND. CSEL.NE.'t') GOTO 70111
            READ(14,*,ERR=70111,END=70111) NTET,VOLWGT
            DO 70100 ITET=1,NTET
               READ(14,*,ERR=70111,END=70111) (IDTET(KTH,ITET),KTH=0,4)
70100       CONTINUE
         ENDIF

      ELSE
* Automatic generation of a mesh if NKPTS.LE.0:
         WRITE(IU6,'(/A)') 'Automatic generation of k-mesh.'
         SHIFT(1)=0.
         SHIFT(2)=0.
         SHIFT(3)=0.
* k-lattice basis vectors in cartesian or reciprocal coordinates?
         IF ((CSEL.NE.'M').AND.(CSEL.NE.'m').AND.
     &       (CSEL.NE.'G').AND.(CSEL.NE.'g')) THEN
* Here give a basis and probably some shift (warning this shift is
* always with respect to the point (0,0,0) ... !
            IF (CSEL.EQ.'K'.OR.CSEL.EQ.'k') THEN
               CSEL='K'
               WRITE(IU6,*)' k-lattice basis in cartesian coordinates'
            ELSE
               WRITE(IU6,*)' k-lattice basis in reciprocal lattice'
            ENDIF
* Read in the basis vectors for the k-lattice (unscaled!!):
            READ(14,*,ERR=70111,END=70111) BK(1,1),BK(2,1),BK(3,1)
            READ(14,*,ERR=70111,END=70111) BK(1,2),BK(2,2),BK(3,2)
            READ(14,*,ERR=70111,END=70111) BK(1,3),BK(2,3),BK(3,3)
* Correct scaling with SCALE ('lattice constant'):
            DO 99498 I=1,3
             DO 99498 J=1,3
99498       BK(J,I)=BK(J,I)/SCALE
* Routine IBZKPT needs cartesian coordinates:
            IF (CSEL.NE.'K') THEN
               CALL DIRKAR(3,BK,B)
            ENDIF
* Read in the shift of the k-mesh: these values must be given in
* k-lattice basis coordinates (usually 0 or 1/2 ...):
            READ(14,*,ERR=70112,END=70112) SHIFT(1),SHIFT(2),SHIFT(3)
70112       CONTINUE
         ELSE
* Here we give the Monkhorst-Pack conventions ... :
            READ(14,*,ERR=70111,END=70111) NKPX,NKPY,NKPZ
* Shift (always in units of the reciprocal lattice vectors!):
            READ(14,*,ERR=70113,END=70113) SHIFT(1),SHIFT(2),SHIFT(3)
70113       CONTINUE
* Internal rescaling and centering according to Monkhorst-Pack:
            IF ((CSEL.EQ.'M').OR.(CSEL.EQ.'m')) THEN
               SHIFT(1)=SHIFT(1)*FLOAT(NKPX)+0.5*MOD(NKPX+1,2)
               SHIFT(2)=SHIFT(2)*FLOAT(NKPY)+0.5*MOD(NKPY+1,2)
               SHIFT(3)=SHIFT(3)*FLOAT(NKPZ)+0.5*MOD(NKPZ+1,2)
            ENDIF
            DO 99500 I=1,3
               BK(I,1)=B(I,1)/FLOAT(NKPX)
               BK(I,2)=B(I,2)/FLOAT(NKPY)
               BK(I,3)=B(I,3)/FLOAT(NKPZ)
99500       CONTINUE
* At this point hope that routine IBZKPT accepts all ... !
         ENDIF
* Find all irreducible points in the first Brillouin zone ... :
         CALL IBZKPT(B,BK,SHIFT,NKPTS,VKPT,WTKPT,NKDIM,
     &               LTET,NTET,IDTET,NTETD,VOLWGT,IKPT,IKPTD,SCALE,IU6)
* set old k-points
         DO 7014 NKP=1,NKPTS
               VKPTL(1,NKP)=VKPT(1,NKP)
               VKPTL(2,NKP)=VKPT(2,NKP)
               VKPTL(3,NKP)=VKPT(3,NKP)
 7014    CONTINUE
      ENDIF

      GOTO 70222
70111 CONTINUE
      WRITE(IU0,*) 'Error reading file KPOINTS. Stopping execution.'
      STOP
70222 CONTINUE

      END

***************** SUBROUTINE LATTICE ***********************************
*
*  subroutine for calculating the reciprocal lattice from the direct
*  lattice
*  in addition the norm of the lattice-vectors and the volume of
*  the basis-cell is calculated
************************************************************************

      SUBROUTINE LATTIC(OMEGA,A,B,ANORM,BNORM,IU6)

      DIMENSION A(3,3),B(3,3),ANORM(3),BNORM(3)

      CALL EXPRO(B(1,1),A(1,2),A(1,3))
      CALL EXPRO(B(1,2),A(1,3),A(1,1))
      CALL EXPRO(B(1,3),A(1,1),A(1,2))

      OMEGA =ABS(B(1,1)*A(1,1)+B(2,1)*A(2,1)+B(3,1)*A(3,1))

      DO 20 I=1,3
      DO 20 J=1,3
        B(I,J)=B(I,J)/OMEGA
  20  CONTINUE

      DO 30 I=1,3
        ANORM(I)=SQRT(A(1,I)*A(1,I)+A(2,I)*A(2,I)+A(3,I)*A(3,I))
        BNORM(I)=SQRT(B(1,I)*B(1,I)+B(2,I)*B(2,I)+B(3,I)*B(3,I))
  30  CONTINUE

      RETURN
      END

***************** SUBROUTINE EXPRO   ***********************************
* EXPRO
* caclulates the x-product of two vectors
*
************************************************************************

      SUBROUTINE EXPRO(H,U1,U2)
      DIMENSION H(3),U1(3),U2(3)

      H(1)=U1(2)*U2(3)-U1(3)*U2(2)
      H(2)=U1(3)*U2(1)-U1(1)*U2(3)
      H(3)=U1(1)*U2(2)-U1(2)*U2(1)

      RETURN
      END

***************** SUBROUTINE KARDIR ************************************
* transform a set of vectors from kartesian coordinates to
* ) direct lattice      (BASIS must be equal to B reciprocal lattice)
* ) reciprocal lattice  (BASIS must be equal to A direct lattice)
************************************************************************

      SUBROUTINE KARDIR(NMAX,V,BASIS)
      DIMENSION V(3,NMAX),BASIS(3,3)

      DO 10 N=1,NMAX
        V1=V(1,N)*BASIS(1,1)+V(2,N)*BASIS(2,1)+V(3,N)*BASIS(3,1)
        V2=V(1,N)*BASIS(1,2)+V(2,N)*BASIS(2,2)+V(3,N)*BASIS(3,2)
        V3=V(1,N)*BASIS(1,3)+V(2,N)*BASIS(2,3)+V(3,N)*BASIS(3,3)
        V(1,N)=V1
        V(2,N)=V2
        V(3,N)=V3
  10  CONTINUE

      RETURN
      END

***************** SUBROUTINE DIRKAR ************************************
* transform a set of vectors from
* ) direct lattice      (BASIS must be equal to A direct lattice)
* ) reciprocal lattice  (BASIS must be equal to B reciprocal lattice)
* to kartesian coordinates
************************************************************************

      SUBROUTINE DIRKAR(NMAX,V,BASIS)
      DIMENSION V(3,NMAX),BASIS(3,3)

      DO 10 N=1,NMAX
        V1=V(1,N)*BASIS(1,1)+V(2,N)*BASIS(1,2)+V(3,N)*BASIS(1,3)
        V2=V(1,N)*BASIS(2,1)+V(2,N)*BASIS(2,2)+V(3,N)*BASIS(2,3)
        V3=V(1,N)*BASIS(3,1)+V(2,N)*BASIS(3,2)+V(3,N)*BASIS(3,3)
        V(1,N)=V1
        V(2,N)=V2
        V(3,N)=V3
  10  CONTINUE

      RETURN
      END

      FUNCTION NWORDS(STRING)
* Find number of blank-delimited words:
      CHARACTER*(*) STRING
      LOGICAL BLANK
      L=LEN(STRING)
      NWORDS=0
      BLANK=.TRUE.
      DO 100 I=L,1,-1
         IF (BLANK.AND.(STRING(I:I).NE.' ')) THEN
            BLANK=.FALSE.
            NWORDS=NWORDS+1
         ELSE IF ((.NOT.BLANK).AND.(STRING(I:I).EQ.' ')) THEN
            BLANK=.TRUE.
         END IF
  100 CONTINUE
      RETURN
      END

      SUBROUTINE FFT3D(C,N,I)
* DUMMY !!!!
      RETURN
      END
