********************************************************************
*
*   program to merge several DOSCAR files labels 1,2 ...
*   written by G. Kresse  version May 95
*
*********************************************************************

      PROGRAM MERGEDOS
      PARAMETER (NDOSD=1001,NDATAD=100,LDIMP=3)
      PARAMETER(NKDIM=100001,NBANDM=100001,TINY=1.E-6)
      CHARACTER*40 HEAD,TYPE,EIGNAM,FORM
      CHARACTER*80 HEADER(5)

      DIMENSION E(NDOSD)
      DIMENSION DOS(NDOSD,LDIMP+1,NDATAD),DOSI(NDOSD,LDIMP+1,NDATAD)
      LOGICAL LPARTIAL

      WRITE(*,*)'Program MERGEDOS'

      NDOSL =-1
      NDATAL=-1

      NIONSL =-1
      NAL    =-1
      JOBPAL =-1
      KBLOCKL=-1
      EMINL  =0
      EMAXL  =0
C--------------------------------------------------------------------
C open current DOSCAR.xx file
C--------------------------------------------------------------------
      NFILES=1000
      DO 520 NF=1,NFILES

      L=INT(LOG10(FLOAT(NF)))+1
      WRITE(FORM,'(A,I1,A)') '(A,I',L,')'
      WRITE(EIGNAM,FORM) 'DOSCAR.',NF
      WRITE(*,*) 'Reading file ',EIGNAM
      OPEN(10,FILE=EIGNAM,STATUS='OLD',ERR=500)

      READ(10,*,ERR=10000) NIONS,NA,JOBPAR,KBLOCK
      IF ((NIONS  .NE.NIONSL  .AND. NIONSL .NE. -1) .OR.
     &    (NA     .NE.NAL     .AND. NAL    .NE. -1) .OR.
     &    (JOBPAR .NE.JOBPAL  .AND. JOBPAL .NE. -1) .OR.
     &    (KBLOCK .NE.KBLOCKL .AND. KBLOCKL.NE. -1)) THEN
         WRITE(*,*) 'DOSCAR header changed'
         STOP
      ENDIF

      NIONSL =NIONS
      NAL    =NA
      JOBPAL =JOBPAR
      KBLOCKL=KBLOCK

      DO 10 I=1,4
         READ(10,'(A)',ERR=10000,END=10000) HEADER(I)
   10 CONTINUE

      IF (JOBPAR.NE.1) THEN
        IPAR=1
        WRITE(*,*)'no partial DOS on file'
      ELSE
        IPAR=4
        WRITE(*,*)'partial DOS on file'
      ENDIF
C--------------------------------------------------------------------
C     read DOS
C--------------------------------------------------------------------
      NDATA=0
  200 CONTINUE
      NDATA=NDATA+1
      IF (NDATA.GT.NDATAD) THEN
        WRITE(*,*)'mergedos: increase NDATAD'
        STOP
      ENDIF

C     first dataset is the total DOS even if partial DOS follows
C     therefore set KBLOCK to 1 for first dataset

      LPARTIAL=.FALSE.
      IF (JOBPAR.EQ.1 .AND. NDATA.NE.1) THEN
        LPARTIAL=.TRUE.
      ENDIF
C  first run init to 0
      IF (NDATAL.EQ.-1) THEN
      DO 100 J=1,IPAR
      DO 100 I=1,NDOSD
        DOS(I,J,NDATA) =0
        DOSI(I,J,NDATA)=0
  100 CONTINUE
      ENDIF
C--------------------------------------------------------------------
C  read in dos
C--------------------------------------------------------------------
      READ(10,*,END=400,ERR=400) EMAX,EMIN,NDOS,EFERM,WEIGHT
      IF ((EMIN   .NE.EMINL   .AND. EMINL  .NE. 0 ) .OR.
     &   (EMAX   .NE.EMAXL   .AND. EMAXL  .NE. 0 ) ) THEN
         WRITE(*,*)'EMIN or EMAX changed'
         STOP
      ENDIF
      EMINL=EMIN
      EMAXL=EMAX
      IF (NF.EQ.1) EFERMI=EFERM

      ISHIFT=(EFERM-EFERMI)/(EMAX-EMIN)*(NDOS-1)+0.5
      WRITE(*,*)'shifting data by ',EFERM-EFERMI,' =',-ISHIFT,
     & ' points'

      IF (NDOS.GT.NDOSD) THEN
         WRITE(*,*) 'NDOS greater than NDOSD, check ...'
         STOP
      ENDIF
      IF (NDOS.NE.NDOSL .AND. NDOSL.NE.-1) THEN
        WRITE(*,*)'NDOS changed ',NDOSL,NDOS
        STOP
      ENDIF
      NDOSL=NDOS
C
C  total DOS
C
      IF (.NOT. LPARTIAL) THEN
        DO 30 I=1,NDOS
          READ(10,*) ES,DOSS,DOSIS
          E(I)   =ES
          ISTORE=I-ISHIFT
          IF (ISTORE.GE.1.AND. ISTORE.LE.NDOS) THEN
          DOS (ISTORE,1,NDATA)=DOSS + DOS(ISTORE,1,NDATA)
          DOSI(ISTORE,1,NDATA)=DOSIS+ DOSI(ISTORE,1,NDATA)
          ENDIF
   30   CONTINUE
C
C  partial DOS
C
      ELSE
        DO 50 I=1,NDOS
          READ(10,*) ES,DOSS,DOSP,DOSD
          E(I)   =ES
          ISTORE=I-ISHIFT
          IF (ISTORE.GE.1.AND. ISTORE.LE.NDOS) THEN
          DOS(ISTORE,2,NDATA) =DOSS + DOS(ISTORE,2,NDATA)
          DOS(ISTORE,3,NDATA) =DOSP + DOS(ISTORE,3,NDATA)
          DOS(ISTORE,4,NDATA) =DOSD + DOS(ISTORE,4,NDATA)
          ENDIF
   50   CONTINUE
      ENDIF
      GOTO 200
C--------------------------------------------------------------------
C  file finished -> next file
C--------------------------------------------------------------------
  400 CONTINUE
      NDATA=NDATA-1
C      IF (JOBPAR.EQ.1) THEN
C        WRITE(*,*)'read partial DOS for',NDATA-1,' ions'
C      ENDIF
C      IF (JOBPAR.EQ.1 .AND. NDATA.EQ.1) THEN
C        WRITE(*,*)'read',NDATA,'datasets'
C      ENDIF

      IF (NDATA.NE.NDATAL .AND. NDATAL.NE.-1) THEN
        WRITE(*,*)'NDATA changed ',NDATAL,NDATA
        STOP
      ENDIF
      NDATAL=NDATA
      CLOSE(10)
C--------------------------------------------------------------------
C  read finished , scale DATA
C--------------------------------------------------------------------
  520 CONTINUE
C 100 files read ...
  500 CONTINUE
      NF=NF-1
      NDATAM=NDATA
      WRITE(*,*)'find a total of ',NF,' files, with',NDATAM,' datas'
                           
      DO 510 NDATA=1,NDATAM

      DO 510 J=1,IPAR
      DO 510 I=1,NDOS
        DOS(I,J,NDATA) = DOS(I,J,NDATA)/NF
        DOSI(I,J,NDATA)= DOS(I,J,NDATA)/NF
  510 CONTINUE
C--------------------------------------------------------------------
C  write merged data
C--------------------------------------------------------------------
      OPEN(10,FILE='DOSCAR')
      WRITE(10,'(4I4)') NIONS,NATA,JOBPAR,KBLOCK
      DO 610 I=1,4
         WRITE(10,'(A)') HEADER(I)
  610 CONTINUE

      DO 600 NDATA=1,NDATAM
      WRITE(10,*) EMAX,EMIN,NDOS,EFERMI,WEIGHT

C     first dataset is the total DOS
      LPARTIAL=.FALSE.

      IF (JOBPAR.EQ.1 .AND. NDATA.NE.1) THEN
        LPARTIAL=.TRUE.
      ENDIF
C  total DOS
C
      IF (.NOT. LPARTIAL) THEN
        DO 630 I=1,NDOS
          WRITE(10,11) E(I),DOS(I,1,NDATA),DOSI(I,1,NDATA)
  630   CONTINUE
C
C  partial DOS
C
      ELSE
        DO 650 I=1,NDOS
          WRITE(10,12) E(I),DOS(I,2,NDATA),
     &                     DOS(I,3,NDATA),
     &                     DOS(I,4,NDATA)
  650   CONTINUE
      ENDIF
  600 CONTINUE
   11   FORMAT(3X,F8.3,3E12.4)
   12   FORMAT(3X,F8.3,6E12.4)

      GOTO 700

10000 WRITE(*,*)'DOSCAR is not readable'
      STOP

  700 CONTINUE

      END
