CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  program band
C  written by Andreas Eichler
C  modifyed by Georg Kern for clean C(111) 
C
C  topic: finding surface-states
C
C  input: PROCAR
C         param.band (optional) ... criterium 1 and 2 
C           format: 2             ... ions per layer
C                   .75 .50 .25   ... criterium 1
C                   .75 .50 .30   ... criterium 2
C           (this are also the default values, c1 ... only the
C           first layer, c2 ... first and second layer)
C
C  output: SBAND.1 ... for mathematica (sband.m) criterium 1 
C          SBAND.2 ... detto, but criterium 2
C          SBAND.user (for user - easy to read)
C
C  parameter: NKDIM ... maximum k-points
C             NBDIM ... maximum bands
C             NDIM  ... maximum ions
C
C  anything else is (nearly) selfexplaining
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      PROGRAM SBANDS
      PARAMETER(NKDIM=55,NBDIM=116,NDIM=51)
      CHARACTER*256 LINE
      DIMENSION RELEN(NKDIM,NBDIM),PARSUM(NKDIM,NBDIM,NDIM)
      DIMENSION C1(3),C2(3)
      DATA NPERL/2/
      DATA C1/0.75,0.50,0.25/
      DATA C2/0.75,0.50,0.30/
      DIMENSION PSUM(6)	

      OPEN(10,FILE='PROCAR',STATUS='OLD')
      OPEN(11,FILE='SBAND.1')
      OPEN(12,FILE='SBAND.user')
      OPEN(13,FILE='SBAND.2')

      READ(10,'(A)') LINE
C here comes the first format for PROCAR
      READ(LINE(15:20),*,ERR=99) NKPTS
      READ(LINE(33:38),*,ERR=99) NBANDS
      READ(LINE(49:55),*,ERR=99) NIONS
      GOTO 100
C and now the second
 99   READ(LINE(15:19),*) NKPTS
      READ(LINE(40:43),*) NBANDS
      READ(LINE(63:66),*) NIONS

 100  WRITE(*,*) '   NIONS NKPTS NBANDS'
      WRITE(*,'(3I6)') NIONS,NKPTS,NBANDS
      IF ((NKPTS.GT.NKDIM).OR.(NBANDS.GT.NBDIM).OR.(NIONS.GT.NDIM)) THEN
        WRITE(*,*) 'ERROR: FIELDS TOO SMALL!!!'
        WRITE(*,*) '       CHECK NKDIM, NBDIM, NDIM'
        WRITE(*,*) 'PROGRAMM WILL BE STOPPED!!!!'
        GOTO 2401
      ENDIF
      WRITE(*,*) 'Please tell me EFERMI :'
      READ(*,*) EFERMI
      WRITE(*,*) EFERMI

       OPEN(9,FILE='param.band',STATUS='OLD',ERR=2303)
         WRITE(*,*) 'reading param.band'
         READ(9,*) NPERL
         READ(9,*) (C1(I),I=1,3)
         READ(9,*) (C2(I),I=1,3)
2303   WRITE(*,*) NPERL
       WRITE(*,*) (C1(I),I=1,3)
       WRITE(*,*) (C2(I),I=1,3)
       CLOSE(9)

      DO 2300 NK=1,NKPTS
        DO I=1,4
          READ(10,'(A)') LINE
        ENDDO
 
        DO 2300 NB=1,NBANDS
          NI=1
          READ(10,*) NDUM,RELEN(NK,NB),RDUM,NDUM,
     &      (RDUM,I=1,3),PARSUM(NK,NB,NI)
          RELEN(NK,NB)=RELEN(NK,NB)-EFERMI
          IF (NIONS.GT.1) THEN
 	    DO NI=2,NIONS
 	      READ(10,*) NDUM,(RDUM,I=1,3),PARSUM(NK,NB,NI)
            ENDDO
            READ(10,'(A)') LINE
            READ(10,'(A)') LINE
          ENDIF
2300    CONTINUE

       WRITE(12,*) 'Kriterium 1 (%1): s(urface) > ',(C1(I),I=1,3)
       WRITE(12,*) 'Kriterium 2 (%2):  s + s-1  > ',(C2(I),I=1,3)
       WRITE(12,*) 'b ... bottom, s ... surface, N ... Ion(Nmax)'
       WRITE(12,*)
       WRITE(12,*) 'k-Pkt   E      Band   %1  %2    b  b-1 s-1',
     &             '  s  N-3 N-2 N-1  N   tot'

       DO 2400 NK=1,NKPTS
       DO 2400 NB=1,NBANDS

C I think it is nessecary to calculate PTOT
         PTOT=0.
         DO 2301 I=1,NIONS
2301	   PTOT=PTOT+PARSUM(NK,NB,I)

         DO 2304 I=1,5
2304       PSUM(I)=0

         DO I=0,NPERL-1
           PSUM(1)=PSUM(1)+PARSUM(NK,NB,NIONS-I)
           PSUM(2)=PSUM(2)+PARSUM(NK,NB,NIONS-NPERL-I)
           PSUM(4)=PSUM(4)+PARSUM(NK,NB,I+1)
           PSUM(5)=PSUM(5)+PARSUM(NK,NB,I+1+NPERL)
         ENDDO
         PSUM(3)=PSUM(1)+PSUM(2)
         PSUM(6)=PSUM(4)+PSUM(5)

C norm PSUM to PTOT 
         DO 2302 I=1,6
2302       PSUM(I)=PSUM(I)/PTOT

         IF(PSUM(1).GT.C1(1)) THEN
           WRITE(11,*) 3,NK,RELEN(NK,NB)
           ELSE IF (PSUM(1).GT.C1(2)) THEN
             WRITE(11,*) 2,NK,RELEN(NK,NB)
           ELSE IF (PSUM(1).GT.C1(3)) THEN
             WRITE(11,*) 1,NK,RELEN(NK,NB)
         ENDIF

         IF(PSUM(3).GT.C2(1)) THEN
           WRITE(13,*) 3,NK,RELEN(NK,NB)
           ELSE IF (PSUM(3).GT.C2(2)) THEN
             WRITE(13,*) 2,NK,RELEN(NK,NB)
           ELSE IF (PSUM(3).GT.C2(3)) THEN
             WRITE(13,*) 1,NK,RELEN(NK,NB)
         ENDIF

         IF( (PSUM(1).GT.C1(3)) .OR. (PSUM(3).GT.C2(3)) ) THEN
           WRITE(12,'(I3,F10.3,I6,2X,2F4.2,2X,8F4.2,F5.2)')
     &       NK,RELEN(NK,NB),NB,PSUM(1),PSUM(3),
     &       PSUM(4)*PTOT,PSUM(5)*PTOT,PSUM(2)*PTOT,
     &       PSUM(1)*PTOT,(PARSUM(NK,NB,I),I=NIONS-3,NIONS),PTOT
         END IF

2400   CONTINUE 	   

2401   CLOSE(10)
       CLOSE(11)
       CLOSE(12)
       CLOSE(13)

      END
